&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wWin 
/*------------------------------------------------------------------------

  File: rtb_modload.w

  Description: Roundtable Module Load SmartWindow

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  History: New RTB-OA version - July 2002
          
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AB.              */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE Mcurrent-wsmod    AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mcurrent-subtype  AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mdef-pmods        AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mdef-subtypes     AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mmodpath          AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mmodule           AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mpath             AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Msrcpaths         AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mworking-dir      AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Mwspace-id        AS CHARACTER   NO-UNDO.
DEFINE VARIABLE MhSrcBuff         AS HANDLE      NO-UNDO.
DEFINE VARIABLE MhSrcQry          AS HANDLE      NO-UNDO.
DEFINE VARIABLE MhTTsrcfile       AS HANDLE      NO-UNDO.
DEFINE VARIABLE Mcurrent-row      AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mi                AS INTEGER     NO-UNDO.
DEFINE VARIABLE Msid              AS INTEGER     NO-UNDO.
DEFINE VARIABLE Msrcfile-entries  AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mtask-num         AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mpmod-prompt      AS LOGICAL     NO-UNDO.
DEFINE VARIABLE Msubtype-prompt   AS LOGICAL     NO-UNDO.
DEFINE VARIABLE Mcurrent-rowid    AS ROWID       NO-UNDO.

&SCOPED-DEFINE ALERT-TITLE "Roundtable Module Load"

DEFINE STREAM Slog.

DEFINE TEMP-TABLE Tpmod-defs NO-UNDO
   FIELD module    AS CHARACTER
   FIELD extension AS CHARACTER
   FIELD pmod      AS CHARACTER.

DEFINE TEMP-TABLE Tsubtype-defs NO-UNDO
   FIELD module    AS CHARACTER
   FIELD extension AS CHARACTER
   FIELD subtype   AS CHARACTER.

DEFINE TEMP-TABLE Tsubtype-parts NO-UNDO
  FIELD module    AS CHARACTER
  FIELD filename  AS CHARACTER
  FIELD partname  AS CHARACTER
  INDEX Tsubtype-parts-01 module
  INDEX Tsubtype-parts-02 filename
  INDEX Tsubtype-parts-03 partname.

/* Dynamics Enhancements - BEGIN */
{src/adm2/globals.i}
{af/sup2/aficfcheck.i}
DEFINE VARIABLE hScmTool              AS HANDLE       NO-UNDO.
DEFINE VARIABLE cMesWinTitle          AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinMessage        AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinButtonList     AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinButtonDefault  AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinButtonCancel   AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinAnswerValue    AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinAnswerDataType AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinAnswerFormat   AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cMesWinButtonPressed  AS CHARACTER    NO-UNDO.
DEFINE VARIABLE lActionUnderway       AS LOGICAL      NO-UNDO.
/* Dynamics Enhancements - END */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target,Filter-target,Filter-Source

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME BR-srcfile

/* Definitions for FRAME fMain                                          */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-1 RECT-2 CB-module TB-Scan-Desc ~
RS-scan-by FI-filespec TB-Scan-All-Mods CB-sub-type BT-Scan BT-Clear ~
BR-srcfile BT-select BT-deselect BT-properties BT-view BT-load BT-delete 
&Scoped-Define DISPLAYED-OBJECTS CB-module TB-Scan-Desc RS-scan-by ~
FI-filespec TB-Scan-All-Mods CB-sub-type 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnMultipleModsSelected wWin 
FUNCTION fnMultipleModsSelected RETURNS LOGICAL PRIVATE
  (  )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnRtbCheckValidSubtypePart wWin 
FUNCTION fnRtbCheckValidSubtypePart RETURNS LOGICAL PRIVATE
  ( INPUT Psub-type  AS CHARACTER,
    INPUT Pfile-name AS CHARACTER,
    INPUT Pmodule    AS CHARACTER,
    INPUT Psubdir    AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnRtbGetAllSubtypePaths wWin 
FUNCTION fnRtbGetAllSubtypePaths RETURNS CHARACTER PRIVATE
  (  )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnRtbGetSubtypePaths wWin 
FUNCTION fnRtbGetSubtypePaths RETURNS CHARACTER PRIVATE
  ( INPUT Psub-type AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnRtbSubtypePartsCount wWin 
FUNCTION fnRtbSubtypePartsCount RETURNS INTEGER PRIVATE
  ( INPUT Psub-type AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR wWin AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Open_Data    LABEL "&Open Data..." 
       MENU-ITEM m_Save_Data    LABEL "&Save Data..." 
       RULE
       MENU-ITEM m_Select_Files LABEL "Selec&t Files..."
       MENU-ITEM m_Deselect_Files LABEL "D&eselect Files..."
       MENU-ITEM m_File_Properties LABEL "&Properties"   
       MENU-ITEM m_File_View    LABEL "&View"         
       RULE
       MENU-ITEM m_Load_Selected_Files LABEL "&Load Selected Files"
       MENU-ITEM m_Unload_Selected_Files LABEL "&Unload Selected Files"
       MENU-ITEM m_Exit         LABEL "E&xit"         .

DEFINE SUB-MENU m_Search 
       MENU-ITEM m_Find         LABEL "&Find..."      .

DEFINE MENU MENU-BAR-wWin MENUBAR
       SUB-MENU  m_File         LABEL "&File"         
       SUB-MENU  m_Search       LABEL "&Search"       .


/* Definitions of handles for SmartObjects                              */
DEFINE VARIABLE h_rtb_q_mod AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_q_ws AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_moddef AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_obj AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_pname AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_subt AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_task AS HANDLE NO-UNDO.
DEFINE VARIABLE h_rtb_u_wspmod AS HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BT-Clear 
     LABEL "&Clear" 
     SIZE 15 BY 1.14 TOOLTIP "Clear objects from list".

DEFINE BUTTON BT-delete 
     LABEL "&Unload..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON BT-deselect 
     LABEL "D&eselect..." 
     SIZE 15 BY 1.14 TOOLTIP "Deselect objects by pattern".

DEFINE BUTTON BT-load 
     LABEL "&Load..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON BT-properties 
     LABEL "&Properties..." 
     SIZE 15 BY 1.14 TOOLTIP "Set properties for selected object(s)".

DEFINE BUTTON BT-Scan 
     LABEL "Sca&n" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BT-select 
     LABEL "Selec&t..." 
     SIZE 15 BY 1.14 TOOLTIP "Select objects by pattern".

DEFINE BUTTON BT-view 
     LABEL "&View" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE CB-module AS CHARACTER FORMAT "X(256)":U 
     LABEL "&Workspace Module" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 25
     DROP-DOWN-LIST
     SIZE 80 BY 1 NO-UNDO.

DEFINE VARIABLE CB-sub-type AS CHARACTER FORMAT "X(256)":U 
     LABEL "Subtype" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 5
     DROP-DOWN-LIST
     SIZE 20 BY 1 NO-UNDO.

DEFINE VARIABLE FI-filespec AS CHARACTER FORMAT "X(256)":U INITIAL "*.*" 
     LABEL "Filespec" 
     VIEW-AS FILL-IN 
     SIZE 20 BY 1 NO-UNDO.

DEFINE VARIABLE RS-scan-by AS CHARACTER 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Scan by f&ilespec", "Filespec",
"Scan by subt&ype", "Subtype"
     SIZE 26 BY 2.38 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL   
     SIZE 108 BY 6.29.

DEFINE RECTANGLE RECT-2
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL   
     SIZE 152 BY 12.24.

DEFINE VARIABLE TB-Scan-All-Mods AS LOGICAL INITIAL no 
     LABEL "Scan all Modules" 
     VIEW-AS TOGGLE-BOX
     SIZE 21 BY .81 NO-UNDO.

DEFINE VARIABLE TB-Scan-Desc AS LOGICAL INITIAL no 
     LABEL "Scan comments to &build descriptions" 
     VIEW-AS TOGGLE-BOX
     SIZE 39 BY .81 TOOLTIP "Toggle on to build object descriptions from comments in source" NO-UNDO.


/* Browse definitions                                                   */
DEFINE BROWSE BR-srcfile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BR-srcfile wWin _STRUCTURED
  
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS NO-COLUMN-SCROLLING MULTIPLE SIZE 130 BY 10.91 ROW-HEIGHT-CHARS .6.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     CB-module AT ROW 2.52 COL 24 COLON-ALIGNED HELP
          "Select Workspace Module"
     TB-Scan-Desc AT ROW 3.86 COL 67 HELP
          "Toggle on to build object descriptions from comments in source"
     RS-scan-by AT ROW 3.91 COL 6 HELP
          "Select scan method" NO-LABEL
     FI-filespec AT ROW 3.91 COL 42 COLON-ALIGNED HELP
          "Enter filespec to load from module directories"
     TB-Scan-All-Mods AT ROW 4.95 COL 67
     CB-sub-type AT ROW 5.1 COL 42 COLON-ALIGNED HELP
          "Select code subtype"
     BT-Scan AT ROW 6.14 COL 75 HELP
          "Scan directories for objects"
     BT-Clear AT ROW 6.14 COL 92 HELP
          "Clear specified objects"
     BR-srcfile AT ROW 9.38 COL 5
     BT-select AT ROW 9.57 COL 137
     BT-deselect AT ROW 11 COL 137
     BT-properties AT ROW 12.43 COL 137
     BT-view AT ROW 13.86 COL 137 HELP
          "View the current source file"
     BT-load AT ROW 15.29 COL 137
     BT-delete AT ROW 16.71 COL 137 HELP
          "Delete current source object from Roundtable"
     " Scan Specs" VIEW-AS TEXT
          SIZE 13.4 BY .95 AT ROW 1 COL 3.6
     " Objects" VIEW-AS TEXT
          SIZE 10 BY .71 AT ROW 8.14 COL 3.6
     RECT-1 AT ROW 1.48 COL 2
     RECT-2 AT ROW 8.52 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 154 BY 20.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target,Filter-target,Filter-Source
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW wWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Roundtable Module Load"
         HEIGHT             = 20
         WIDTH              = 154
         MAX-HEIGHT         = 320
         MAX-WIDTH          = 320
         VIRTUAL-HEIGHT     = 320
         VIRTUAL-WIDTH      = 320
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = yes
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-wWin:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wWin 
/* ************************* Included-Libraries *********************** */

{rtb/i/rtb_super.i}
{rtb/admtwo/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW wWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   FRAME-NAME                                                           */
/* BROWSE-TAB BR-srcfile BT-Clear fMain */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
THEN wWin:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BR-srcfile
/* Query rebuild information for BROWSE BR-srcfile
     _Options          = "NO-LOCK"
     _Query            is NOT OPENED
*/  /* BROWSE BR-srcfile */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON END-ERROR OF wWin /* Roundtable Module Load */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-CLOSE OF wWin /* Roundtable Module Load */
DO:
  /* This ADM code must be left here in order for the SmartWindow
     and its descendents to terminate properly on exit. */
  RUN exitObject.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-RESIZED OF wWin /* Roundtable Module Load */
DO:
  RUN resizeWidgets.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BR-srcfile
&Scoped-define SELF-NAME BR-srcfile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-srcfile wWin
ON CTRL-A OF BR-srcfile IN FRAME fMain
DO:
  SELF:SELECT-ALL(). 
  RUN set_sensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-srcfile wWin
ON START-SEARCH OF BR-srcfile IN FRAME fMain
DO:
  DEFINE VARIABLE Msort AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MhCol AS HANDLE      NO-UNDO.

  ASSIGN MhCol              = SELF:CURRENT-COLUMN
         MhCol:PRIVATE-DATA = IF MhCol:PRIVATE-DATA = "descending":U THEN
                                "ascending":U
                              ELSE IF MhCol:PRIVATE-DATA = "ascending":U THEN
                                "descending":U
                              ELSE
                                "ascending":U
         Msort              = IF MhCol:PRIVATE-DATA = "descending":U THEN
                                "descending":U
                              ELSE
                                 "".
  IF TB-Scan-All-Mods:CHECKED THEN
    MhSrcQry:QUERY-PREPARE(SUBSTITUTE("for each &1 by &2 &3",
                                    MhTTsrcfile:NAME,
                                    MhCol:NAME,
                                    Msort)).
  ELSE
    MhSrcQry:QUERY-PREPARE(SUBSTITUTE("for each &1 where module = '&2' by &3 &4",
                                      MhTTsrcfile:NAME,
                                      Mcurrent-wsmod,
                                      MhCol:NAME,
                                      Msort)).
  MhSrcQry:QUERY-OPEN.

  APPLY "END-SEARCH":U TO SELF.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-srcfile wWin
ON VALUE-CHANGED OF BR-srcfile IN FRAME fMain
DO:
  ASSIGN Mcurrent-row   = SELF:FOCUSED-ROW
         Mcurrent-rowid = MhSrcBuff:ROWID.
  RUN set_sensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-Clear
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-Clear wWin
ON CHOOSE OF BT-Clear IN FRAME fMain /* Clear */
DO:
  RUN clear_srcfile_recs.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-delete
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-delete wWin
ON CHOOSE OF BT-delete IN FRAME fMain /* Unload... */
DO:
  RUN unload_objects.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-deselect
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-deselect wWin
ON CHOOSE OF BT-deselect IN FRAME fMain /* Deselect... */
DO:
  RUN select_files (INPUT "deselect":U).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-load
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-load wWin
ON CHOOSE OF BT-load IN FRAME fMain /* Load... */
DO:
  RUN load_objects.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-properties
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-properties wWin
ON CHOOSE OF BT-properties IN FRAME fMain /* Properties... */
DO:
  RUN set_object_properties.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-Scan
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-Scan wWin
ON CHOOSE OF BT-Scan IN FRAME fMain /* Scan */
DO:
  IF TB-Scan-All-Mods:CHECKED THEN
    RUN scan_all_directories.
  ELSE
    RUN scan_directories.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-select
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-select wWin
ON CHOOSE OF BT-select IN FRAME fMain /* Select... */
DO:
  RUN select_files (INPUT "select":U).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BT-view
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BT-view wWin
ON CHOOSE OF BT-view IN FRAME fMain /* View */
DO:
  RUN view_selected_file.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CB-module
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CB-module wWin
ON VALUE-CHANGED OF CB-module IN FRAME fMain /* Workspace Module */
DO:
  IF SELF:SCREEN-VALUE <> Mcurrent-wsmod THEN
    RUN set_module_query (INPUT SELF:SCREEN-VALUE).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CB-sub-type
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CB-sub-type wWin
ON VALUE-CHANGED OF CB-sub-type IN FRAME fMain /* Subtype */
DO:
  RUN set_subtype_query (INPUT SELF:SCREEN-VALUE).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Deselect_Files
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Deselect_Files wWin
ON CHOOSE OF MENU-ITEM m_Deselect_Files /* Deselect Files... */
DO:
  RUN select_files (INPUT "deselect":U).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit wWin
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  RUN exitObject.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_File_Properties
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_File_Properties wWin
ON CHOOSE OF MENU-ITEM m_File_Properties /* Properties */
DO:
  RUN set_object_properties.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_File_View
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_File_View wWin
ON CHOOSE OF MENU-ITEM m_File_View /* View */
DO:
  RUN view_selected_file.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Find
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Find wWin
ON CHOOSE OF MENU-ITEM m_Find /* Find... */
DO:
  RUN find_object.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Load_Selected_Files
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Load_Selected_Files wWin
ON CHOOSE OF MENU-ITEM m_Load_Selected_Files /* Load Selected Files */
DO:
  RUN load_objects.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Open_Data
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Open_Data wWin
ON CHOOSE OF MENU-ITEM m_Open_Data /* Open Data... */
DO:
  RUN open_data_file.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Save_Data
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Save_Data wWin
ON CHOOSE OF MENU-ITEM m_Save_Data /* Save Data... */
DO:
  RUN save_data_file.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Select_Files
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Select_Files wWin
ON CHOOSE OF MENU-ITEM m_Select_Files /* Select Files... */
DO:
  RUN select_files (INPUT "select":U).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Unload_Selected_Files
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Unload_Selected_Files wWin
ON CHOOSE OF MENU-ITEM m_Unload_Selected_Files /* Unload Selected Files */
DO:
  RUN unload_objects.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME RS-scan-by
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL RS-scan-by wWin
ON VALUE-CHANGED OF RS-scan-by IN FRAME fMain
DO:
  RUN set_sensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME TB-Scan-All-Mods
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TB-Scan-All-Mods wWin
ON VALUE-CHANGED OF TB-Scan-All-Mods IN FRAME fMain /* Scan all Modules */
DO:
  IF SELF:CHECKED THEN
    RUN set_all_query.
  ELSE
    RUN set_module_query (INPUT CB-module:SCREEN-VALUE).
  RUN set_sensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wWin 


/* ***************************  Main Block  *************************** */
{rtb/i/rtb_resizeable.i}

/* Include custom  Main Block code for SmartWindows. */
{rtb/admtwo/windowmn.i}

fnRtbStartSuperProc("rtb/p/rtb_fileio.p",SESSION).

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE add_srcfile_rec wWin 
PROCEDURE add_srcfile_rec :
/*------------------------------------------------------------------------------
  Purpose:     Add file record to temp-table
  Parameters:  INPUT Pbasename - Basename provided through OS-DIR
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Pbasename AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE Mextension AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mflags     AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mresult    AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mx         AS INTEGER   NO-UNDO.

  process-file:
  DO:
    /*
     If object is .r code or .wrx then skip it
    */
    IF NOT(Pbasename MATCHES "*~~.r") AND NOT (Pbasename MATCHES "*~~.wrx") THEN DO:
      /*
       Check if object/physical part name already exists...
      */
      IF DYNAMIC-FUNCTION('fnRtbCheckPnameExists':U IN h_rtb_u_pname,
                          INPUT Mwspace-id,
                          INPUT Mmodpath
                                 + (IF Mmodpath <> "" AND ENTRY(Mi,Msrcpaths) <> "" THEN
                                     "/" + ENTRY(Mi,Msrcpaths)
                                    ELSE
                                      ""),
                          INPUT Pbasename) THEN
        LEAVE process-file.

      MhSrcBuff:FIND-FIRST(SUBSTITUTE("WHERE filename = '&1' AND module = '&2'",Pbasename,Mmodule),NO-LOCK)
        NO-ERROR.

      IF MhSrcBuff:AVAILABLE THEN
        LEAVE process-file.

      IF RS-scan-by:SCREEN-VALUE IN FRAME {&FRAME-NAME} = "Subtype"
         AND NOT CB-sub-type:SCREEN-VALUE IN FRAME {&FRAME-NAME} = " All"
         AND NOT DYNAMIC-FUNCTION('fnRtbCheckValidSubtypePart':U,
                                  INPUT Mcurrent-subtype,
                                  INPUT Pbasename,
                                  INPUT Mmodule,
                                  INPUT ENTRY(Mi,Msrcpaths)) THEN
        LEAVE process-file.


      /*
       Ignore files already assoicated as a subtype part
      */
      IF CAN-FIND(Tsubtype-parts
                  WHERE Tsubtype-parts.module   = Mmodule
                    AND Tsubtype-parts.partname = Pbasename) THEN
        LEAVE process-file.

      MhSrcBuff:BUFFER-CREATE().

      /*
       If the object name is blank we will prompt for it later
      */
      ASSIGN 
        MhSrcBuff:BUFFER-FIELD("object":U):BUFFER-VALUE     = Pbasename
        MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE   = Pbasename
        MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE = "New"
        MhSrcBuff:BUFFER-FIELD("fullpath":U):BUFFER-VALUE   = Mpath + "/" + Pbasename
        MhSrcBuff:BUFFER-FIELD("selected":U):BUFFER-VALUE   = FALSE
        MhSrcBuff:BUFFER-FIELD("extension":U):BUFFER-VALUE  = Mextension
        MhSrcBuff:BUFFER-FIELD("subdir":U):BUFFER-VALUE     = ENTRY(Mi,Msrcpaths)
        MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE     = Mmodule
        MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE       = ""
        MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE   = ""
        MhSrcBuff:BUFFER-FIELD("defaults":U):BUFFER-VALUE   = NO
        Msrcfile-entries    = Msrcfile-entries + 1.

      /*
       Scan for descriptions comments
      */  
      IF TB-Scan-Desc:CHECKED IN FRAME {&FRAME-NAME} THEN
        RUN scan_for_comments.

    END. /*- if not Pbasename -*/

  END. /*- Mresult = 0 -*/

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/
  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.

  ASSIGN currentPage = getCurrentPage().

  CASE currentPage: 

    WHEN 0 THEN DO:
       RUN constructObject (
             INPUT  'rtb/sdo/rtb_q_mod.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessyesDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_q_modOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_q_mod ).
       RUN repositionObject IN h_rtb_q_mod ( 1.00 , 1.00 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_moddef.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsrtb.rtb_moddef.module,moduleObjectNamertb_u_moddefOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_moddef ).
       RUN repositionObject IN h_rtb_u_moddef ( 1.00 , 10.80 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_subt.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_u_subtOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_subt ).
       RUN repositionObject IN h_rtb_u_subt ( 1.00 , 21.00 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_obj.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_u_objOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_obj ).
       RUN repositionObject IN h_rtb_u_obj ( 1.00 , 30.40 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_task.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_u_taskOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_task ).
       RUN repositionObject IN h_rtb_u_task ( 1.00 , 40.20 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_q_ws.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_q_wsOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_q_ws ).
       RUN repositionObject IN h_rtb_q_ws ( 1.00 , 50.00 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_pname.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_u_pnameOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_pname ).
       RUN repositionObject IN h_rtb_u_pname ( 1.00 , 69.60 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       RUN constructObject (
             INPUT  'rtb/sdo/rtb_u_wspmod.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceroundtableASInfoASUsePrompt?CacheDuration0CheckCurrentChangedyesDestroyStatelessnoDisconnectAppServernoServerOperatingModeNONEShareDatanoUpdateFromSourcenoForeignFieldsObjectNamertb_u_wspmodOpenOnInitnoPromptColumns(NONE)PromptOnDeleteyesRowsToBatch200RebuildOnReposnoToggleDataTargetsyes':U ,
             OUTPUT h_rtb_u_wspmod ).
       RUN repositionObject IN h_rtb_u_wspmod ( 1.00 , 81.00 ) NO-ERROR.
       /* Size in AB:  ( 1.86 , 10.80 ) */

       /* Links to SmartDataObject h_rtb_u_moddef. */
       RUN addLink ( h_rtb_q_mod , 'Data':U , h_rtb_u_moddef ).

       /* Adjust the tab order of the smart objects. */
    END. /* Page 0 */

  END CASE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE build_source_list wWin 
PROCEDURE build_source_list PRIVATE :
/* -----------------------------------------------------------
  Purpose:     Build the Tscrfile temp-table.
  Parameters:  INPUT Pwsmod    - Workspace Module
               INPUT Pscan-by  - "Filespec" or "Subtype"
               INPUT Pfilespec - Filespec
               INPUT Psub-type - Selected code sub-type
  Notes:       
-------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwsmod    AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pscan-by  AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pfilespec AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Psub-type AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE Mbasename      AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mfileattr      AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mfilename      AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mfilespec      AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mdef-pmod      AS CHARACTER     NO-UNDO.
  DEFINE VARIABLE Mdef-subtype   AS CHARACTER     NO-UNDO.

  /*
   Find the module
  */
  IF DYNAMIC-FUNCTION('fnRtbFetchModuleRecord':U IN h_rtb_q_mod,Pwsmod) THEN
    ASSIGN Mmodule  = Pwsmod
           Mmodpath = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_moddef,'directory':U),CHR(1)).
  /*
   Set wait and tell 'em what we're up to
  */
  STATUS DEFAULT "Scanning module directories.  Please wait...".
  SESSION:SET-WAIT-STATE("General").

  /*
   Step 1:

   Using the sub-type definitions we generate a list of sub-directories 
   in which PCODE text file parts are allowed to exist.
  */
  Msrcpaths = IF Pscan-by = "Filespec":U OR Psub-type = " All":U THEN
                DYNAMIC-FUNCTION('fnRtbGetAllSubtypePaths':U)
              ELSE
                 DYNAMIC-FUNCTION('fnRtbGetSubtypePaths':U,Psub-type).
  IF Msrcpaths = "" THEN Msrcpaths = ",".

  RUN set_working_directory.

  /*
   If we are scanning by Subtype, we want to make sure we ignore any previously
   entered file spec...
  */
  IF Pscan-by = "Subtype" THEN Pfilespec = "*.*".

  /*
   Step 2:

   Build workfile of files in each sub-directory.
  */
    srcpaths-loop:
    DO Mi = 1 TO NUM-ENTRIES(Msrcpaths):
  
      /*
       Don't search path if it has been already searched
      */
      IF LOOKUP(ENTRY(Mi,Msrcpaths),Msrcpaths) < Mi THEN NEXT srcpaths-loop.
  
      ASSIGN Mpath = Mworking-dir +
                (IF Mmodpath <> "" THEN 
                   "/" + Mmodpath 
                 ELSE 
                   "") +
                (IF ENTRY(Mi,Msrcpaths) <> "" THEN 
                   "/" + ENTRY(Mi,Msrcpaths)
                 ELSE 
                   "").
  
      /*
       Check that the directory actually exists
  
       File-type will contain a "D" if it is a directory (as opposed
       to a regular file), and will be ? if it doesn't exist at all.
      */
      ASSIGN FILE-INFO:FILE-NAME = Mpath.          
  
      IF INDEX(FILE-INFO:FILE-TYPE,"D") < 1 OR 
         INDEX(FILE-INFO:FILE-TYPE,"D") = ? THEN 
        NEXT srcpaths-loop.
  
      Mfilespec = REPLACE(Pfilespec,"~.","~~.").
  
      INPUT FROM OS-DIR(Mpath).
  
      $FILES-LOOP:
      REPEAT:
        
        IMPORT Mbasename Mfilename Mfileattr.
        
        IF NOT (Mbasename MATCHES Mfilespec) THEN
          NEXT $FILES-LOOP.
    
        /* We only want regular files (not hidden, links or pipes) */
        IF INDEX(Mfileattr,"F") < 1 THEN
          NEXT $FILES-LOOP.
        IF INDEX(Mfileattr,"H") > 0 OR INDEX(Mfileattr,"L") >0 OR INDEX(Mfileattr,"P") > 0 THEN
          NEXT $FILES-LOOP.
    
        RUN add_srcfile_rec (Mbasename).
      
      END. /* $files-loop */
  
      INPUT CLOSE.
  
    END.  /* srcpaths-loop */

  /*
   Open query and browser
  */
  DO WITH FRAME {&FRAME-NAME}:
    IF NOT TB-Scan-All-Mods:CHECKED THEN DO:
      RUN set_module_query (INPUT CB-module:SCREEN-VALUE).
      MhSrcQry:REPOSITION-TO-ROW(1).
      Br-srcfile:MAX-DATA-GUESS = Msrcfile-entries.
    END.
  END.

  /*
   End wait, hide message
  */
  STATUS DEFAULT.
  SESSION:SET-WAIT-STATE("").

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE clear_srcfile_recs wWin 
PROCEDURE clear_srcfile_recs PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Remove records from table matching filespec or subtype.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mcriterion AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpattern   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MhQuery    AS HANDLE      NO-UNDO.
  DEFINE VARIABLE Mrecs      AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mclear     AS LOGICAL     NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:
    Mcriterion = IF RS-scan-by:SCREEN-VALUE = "Filespec":U THEN
                   SUBSTITUTE("filespec '&1'",FI-filespec:SCREEN-VALUE)
                 ELSE
                   SUBSTITUTE("sub-type '&1'",CB-sub-type:SCREEN-VALUE).

    MESSAGE SUBSTITUTE("Remove unloaded objects from list with &1?",Mcriterion)
      VIEW-AS ALERT-BOX WARNING BUTTONS YES-NO TITLE {&ALERT-TITLE}
      UPDATE Mclear.

    IF Mclear = YES THEN DO:
      
      IF RS-scan-by:SCREEN-VALUE = "Filespec":U THEN
        /*
         Look for literal dot in MATCHES pattern, not any single character
        */
        Mpattern = REPLACE(FI-filespec:SCREEN-VALUE,".","~~.").

      CREATE QUERY MhQuery.
      MhQuery:SET-BUFFERS(MhSrcBuff).
      MhQuery:QUERY-PREPARE(SUBSTITUTE("FOR EACH &1~
                                        WHERE &2~
                                          AND obj-status <> 'Done'~
                                          AND &3",
                                        MhSrcBuff:NAME,
                                        (IF TB-Scan-All-Mods:CHECKED THEN
                                           "TRUE"
                                         ELSE
                                            "module = '" + CB-module:SCREEN-VALUE + "'"),
                                        (IF RS-scan-by:SCREEN-VALUE = "Filespec":U THEN
                                           SUBSTITUTE("filename MATCHES '&1'",Mpattern)
                                         ELSE IF CB-sub-type:SCREEN-VALUE = " All":U THEN
                                           "TRUE"
                                         ELSE
                                           SUBSTITUTE("sub-type = '&1'",CB-sub-type:SCREEN-VALUE)))).

      MhQuery:FORWARD-ONLY = TRUE.
      MhQuery:QUERY-OPEN.
      MhQuery:GET-FIRST.

      DO WHILE TRUE:
        IF MhQuery:QUERY-OFF-END THEN LEAVE.
        /*
         Remove any associated parts
        */
        FOR EACH Tsubtype-parts
          WHERE Tsubtype-parts.module   = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
            AND Tsubtype-parts.filename = STRING(MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE):
          DELETE Tsubtype-parts.
        END.

        MhSrcBuff:BUFFER-DELETE().  
        Mrecs = Mrecs + 1.

        MhQuery:GET-NEXT.
      END.

      BROWSE BR-srcfile:REFRESH().
      MESSAGE SUBSTITUTE("&1 object(s) were removed from the list.",Mrecs)
        VIEW-AS ALERT-BOX INFO TITLE {&ALERT-TITLE}.

      DELETE OBJECT MhQuery.

    END. /* mclear = yes */

  END.

  RUN set_sensitive.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
  THEN DELETE WIDGET wWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY CB-module TB-Scan-Desc RS-scan-by FI-filespec TB-Scan-All-Mods 
          CB-sub-type 
      WITH FRAME fMain IN WINDOW wWin.
  ENABLE RECT-1 RECT-2 CB-module TB-Scan-Desc RS-scan-by FI-filespec 
         TB-Scan-All-Mods CB-sub-type BT-Scan BT-Clear BT-select BT-deselect 
         BT-properties BT-view BT-load BT-delete 
      WITH FRAME fMain IN WINDOW wWin.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
  VIEW wWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE exitObject wWin 
PROCEDURE exitObject :
/*------------------------------------------------------------------------------
  Purpose:  Window-specific override of this procedure which destroys 
            its contents and itself.
    Notes:  
------------------------------------------------------------------------------*/

  /*
   Delete dynamic objects..
  */
  DELETE OBJECT MhTTsrcfile.
  DELETE OBJECT MhSrcQry.

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fill_defaults wWin 
PROCEDURE fill_defaults PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Populate pmod and subtype values for objects in table.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Merror            AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mfilename         AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mpmod-decide      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Msubtype-decide   AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mdef-pmod         AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mdef-subtype      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mparts            AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Msubtype-def-pmod AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE MhField           AS HANDLE    NO-UNDO.
  DEFINE VARIABLE MhDefQry          AS HANDLE    NO-UNDO. /* Local Query */

  DEFINE VARIABLE Mlog AS LOGICAL    NO-UNDO INIT NO.

  /*
    MhSrcQry is used by the browser, so we use a tempoorary query here
   to allow a forward-only query.
  */
  CREATE QUERY MhDefQry.
  MhDefQry:SET-BUFFERS(MhSrcBuff).
  MhDefQry:QUERY-PREPARE(SUBSTITUTE("for each &1~
                                   where &1.module = '&2'~
                                     and &1.defaults = no",
                                   MhTTsrcfile:NAME,Mmodule)).
  MhDefQry:FORWARD-ONLY = TRUE.
  MhDefQry:QUERY-OPEN().
  MhDefQry:GET-FIRST().

  /*
   Start wait state
  */
  STATUS DEFAULT "Setting defaults.  Please wait...".
  SESSION:SET-WAIT-STATE("GENERAL":U).  

  DO WHILE TRUE:
    IF MhDefQry:QUERY-OFF-END THEN LEAVE.

    /*
     When consolidating multi-part objects, we may have deleted a row
     in the result set -- process only when record exists
    */
    IF MhSrcBuff:AVAILABLE THEN DO:

      ASSIGN Mfilename = MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE.

      IF MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE = "" THEN DO:

        /*
         Determine and assign a pmod to this file
        */
        MhField = MhSrcBuff:BUFFER-FIELD("pmod").
               
        IF R-INDEX(Mfilename,".") = 0 AND
           CAN-FIND(FIRST Tpmod-defs 
                    WHERE Tpmod-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
                      AND Tpmod-defs.extension = "") THEN DO:
          FIND FIRST Tpmod-defs
            WHERE Tpmod-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
              AND Tpmod-defs.extension = "" NO-LOCK NO-ERROR.
          MhField:BUFFER-VALUE = IF AVAILABLE Tpmod-defs THEN
                                   Tpmod-defs.pmod
                                 ELSE
                                   "". 
        END.  /* if rindex(mfilename,".") = 0 */  
        ELSE IF R-INDEX(Mfilename,".") > 0 AND
           CAN-FIND(FIRST Tpmod-defs
                    WHERE Tpmod-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
                      AND Tpmod-defs.extension = SUBSTRING(Mfilename,R-INDEX(Mfilename,"."))) THEN DO:
          FIND FIRST Tpmod-defs
            WHERE Tpmod-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
              AND Tpmod-defs.extension = SUBSTRING(Mfilename,R-INDEX(Mfilename,".")) 
            NO-LOCK NO-ERROR.
          MHField:BUFFER-VALUE = IF AVAILABLE Tpmod-defs THEN
                                   Tpmod-defs.pmod
                                 ELSE
                                   "".                                          
        END.  /* if can-find */
        ELSE IF Mpmod-decide = "any-file":U THEN DO:
          MhField:BUFFER-VALUE = Mdef-pmod.        
        END.
        ELSE DO:           
          IF NUM-ENTRIES(Mdef-pmods) > 1 THEN DO:
            /*
             Get default pmod
            */
            IF Mpmod-prompt THEN DO:

              SESSION:SET-WAIT-STATE("").
              RUN get_default_pmod (INPUT Mfilename,
                                    OUTPUT Mdef-pmod,
                                    OUTPUT Mpmod-decide).  
              STATUS DEFAULT "Setting defaults.  Please wait...".
              SESSION:SET-WAIT-STATE("GENERAL":U).

              IF Mpmod-decide = "Later":U THEN
                ASSIGN Mpmod-prompt = NO.
            
              IF Mpmod-decide = "this-extension":U THEN DO:
                CREATE Tpmod-defs.
                ASSIGN Tpmod-defs.module    = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
                       Tpmod-defs.extension = IF INDEX(Mfilename,".") = 0 THEN
                                                ""
                                              ELSE
                                                SUBSTRING(Mfilename,R-INDEX(Mfilename,"."))
                       Tpmod-defs.pmod      = Mdef-pmod.
              END.  /* if mpmod-decide = "this-extension */
            END. /* if mpod-prompt */
          END.
          ELSE
            Mdef-pmod = Mdef-pmods.

          IF Mdef-pmod <> "" THEN
            MhField:BUFFER-VALUE = Mdef-pmod.

        END.  /* else do */

      END. /* if tsrcfile.pmod = "" */

      IF MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE = "" THEN DO:

        MhField = MhSrcBuff:BUFFER-FIELD("sub-type":U).

        IF Msubtype-def-pmod = "" THEN
          ASSIGN  Msubtype-def-pmod = Mdef-pmod.

        /*
         Determine and assign a subtype to this file
        */
        IF R-INDEX(Mfilename,".") = 0 AND
           CAN-FIND(FIRST Tsubtype-defs WHERE 
                          Tsubtype-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE) AND
                          Tsubtype-defs.extension = "") THEN DO:

          FIND FIRST Tsubtype-defs WHERE 
                     Tsubtype-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
                 AND Tsubtype-defs.extension = "" 
            NO-LOCK NO-ERROR.

          MhField:BUFFER-VALUE = IF AVAILABLE Tsubtype-defs THEN
                                   Tsubtype-defs.subtype
                                 ELSE
                                   "".

        END.  /* if rindex(tsrcfile.filename,".") = 0 */
        ELSE IF R-INDEX(Mfilename,".") > 0 AND
           CAN-FIND(FIRST Tsubtype-defs WHERE
                          Tsubtype-defs.extension = SUBSTRING(Mfilename,R-INDEX(Mfilename,".")) AND
                          Tsubtype-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)) THEN DO:

          FIND FIRST Tsubtype-defs WHERE
                     Tsubtype-defs.extension = SUBSTRING(Mfilename,R-INDEX(Mfilename,".")) AND
                     Tsubtype-defs.module = STRING(MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE)
                    NO-LOCK NO-ERROR.

          IF AVAILABLE Tsubtype-defs THEN DO:
            /*
             Ensure subtype with same extension is ok
            */
            Merror = DYNAMIC-FUNCTION('fnRtbGetObjectPartnames':U IN h_rtb_u_pname,
                                      INPUT "",
                                      INPUT MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE,
                                      INPUT Tsubtype-defs.subtype,
                                      INPUT Mfilename,
                                      INPUT "PCODE":U,
                                      OUTPUT Mparts).
            
            MhField:BUFFER-VALUE =  IF Merror = ""
                                       AND INDEX(REPLACE(MhSrcBuff:BUFFER-FIELD("fullpath":U):BUFFER-VALUE,"\","/"),
                                           REPLACE(ENTRY(1,Mparts),"\","/")) > 0 THEN
                                      Tsubtype-defs.subtype
                                    ELSE
                                     "".
          END.  /* if available tsubtype-defs */
          ELSE
            MhField:BUFFER-VALUE = "".
        END.  /* if can-find */
        ELSE IF Msubtype-decide = "any-file":U THEN DO:

          /*
           Ensure that default subtype is ok
          */
          MhField:BUFFER-VALUE = IF DYNAMIC-FUNCTION('fnRtbCheckValidSubtypePart':U,
                                                     Mdef-subtype,
                                                     Mfilename,
                                                     MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE,
                                                     MhSrcBuff:BUFFER-FIELD("subdir":U):BUFFER-VALUE) THEN
                                   Mdef-subtype
                                 ELSE
                                   "".

        END.  /* else if msubtype-decide = "any-file" */
        ELSE DO:
          /*
           Find default subtype
          */
          IF Msubtype-prompt THEN DO:
            SESSION:SET-WAIT-STATE("").
            RUN get_default_subtype (INPUT Mfilename,
                                     INPUT MhSrcBuff:BUFFER-FIELD("subdir":U):BUFFER-VALUE,
                                     OUTPUT Mdef-subtype,
                                     OUTPUT Msubtype-decide).
            STATUS DEFAULT "Setting defaults.  Please wait...".
            SESSION:SET-WAIT-STATE("GENERAL":U).

            IF Msubtype-decide = "Later" THEN
              Msubtype-prompt = NO.

            IF Msubtype-decide = "this-extension" THEN DO:
              CREATE Tsubtype-defs.
              ASSIGN Tsubtype-defs.extension = IF INDEX(Mfilename,".") = 0 THEN
                                                 ""
                                               ELSE
                                                 SUBSTRING(Mfilename,R-INDEX(Mfilename,"."))
                     Tsubtype-defs.subtype   = Mdef-subtype
                     Tsubtype-defs.module    = MhSrcBuff:BUFFER-FIELD("module"):BUFFER-VALUE.
            END.  /* if subtype-decide = "this-extension */
          END.

          IF Mdef-subtype <> "" THEN
            ASSIGN MhField:BUFFER-VALUE = Mdef-subtype.

        END.  /* else do */

        IF MhField:BUFFER-VALUE <> "" 
           AND fnRtbSubtypePartsCount(MhField:BUFFER-VALUE) > 1 THEN
          RUN remove_subtype_parts (INPUT MhField:BUFFER-VALUE,
                                    INPUT Mfilename).
      
      END. /* if tsrcfile.sub-type = "" */

      MhSrcBuff:BUFFER-FIELD("defaults":U):BUFFER-VALUE = YES.

    END. /* mhsrcbuff:available */

    MhDefQry:GET-NEXT().

  END.  /* do while true */

  MhDefQry:QUERY-CLOSE().
  DELETE OBJECT MhDefQry NO-ERROR.

  /*
   Refresh the browse
  */
  DO WITH FRAME {&FRAME-NAME}:
    RUN set_module_query (CB-module:SCREEN-VALUE).
    IF MhSrcQry:NUM-RESULTS > 0 THEN
      BR-srcfile:REFRESH() IN FRAME {&FRAME-NAME}.  
  END.

  STATUS DEFAULT.
  SESSION:SET-WAIT-STATE("").      

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fill_subtype_combo wWin 
PROCEDURE fill_subtype_combo PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Populate subtype combo-box with available subtypes.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DO WITH FRAME {&FRAME-NAME}:
    DYNAMIC-FUNCTION('fnRtbFillSubtypesWidget':U IN h_rtb_u_subt,
                     CB-sub-type:HANDLE).
    CB-sub-type:ADD-FIRST(" All":U).
    CB-sub-type:SCREEN-VALUE = CB-sub-type:ENTRY(1).
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fill_wsmod_combo wWin 
PROCEDURE fill_wsmod_combo PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Populate Workspace module combo with available workspace modules.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DO WITH FRAME {&FRAME-NAME}:
    DYNAMIC-FUNCTION('fnRtbFillModuleWidget':U IN h_rtb_q_mod,CB-module:HANDLE).
    CB-module:SCREEN-VALUE = CB-module:ENTRY(1) NO-ERROR.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE find_object wWin 
PROCEDURE find_object :
/*------------------------------------------------------------------------------
  Purpose:     Search for a filename in the current table.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mobject AS CHARACTER   NO-UNDO.

  RUN rtb/w/rtb_gets.w
    (INPUT "Find Object" + CHR(1)
            + "Object"   + CHR(1)
            + "32"         + CHR(1)
            + "x(256)",
     OUTPUT Mobject).

  IF Mobject <> ? THEN DO:
    MhSrcBuff:FIND-FIRST(SUBSTITUTE("where module = '&1' and object = '&2'",
                                    Mcurrent-wsmod,Mobject)) NO-ERROR.
    IF MhSrcBuff:AVAILABLE THEN DO:
      MhSrcQry:REPOSITION-TO-ROWID(MhSrcBuff:ROWID).
      APPLY "ENTRY" TO BR-srcfile IN FRAME {&FRAME-NAME}.
    END.
    ELSE DO:
      MESSAGE SUBSTITUTE("Filename '&1' is not in current table.",Mobject)
        VIEW-AS ALERT-BOX ERROR TITLE {&ALERT-TITLE}.
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_default_dialog wWin 
PROCEDURE get_default_dialog PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Display a dialog to prompt user for product module or code
               subtype to use for specified object.
  Parameters:  INPUT Pobject  - the filename requiring user disposition
               INPUT Pmode    - 'Product Module' or 'Code Subtype'
               INPUT Pvalues  - Comma-delimited list of possible values
               OUTPUT Pvalue  - Value selected by user
               OUTPUT Poption - 'this-file', 'this-extension', 'any-file', or
                                'Later'
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Pobject AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER Pmode   AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER Pvalues AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Pvalue  AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Poption AS CHARACTER   NO-UNDO.

  /*
   Define a dialog box...
  */

  /*
   Definitions of the field level widgets
  */
  DEFINE BUTTON BT-Cancel AUTO-END-KEY 
       LABEL "&Cancel" 
       SIZE 15 BY 1.14
       BGCOLOR 8 .

  DEFINE BUTTON BT-Ok AUTO-GO 
       LABEL "&OK" 
       SIZE 15 BY 1.14
       BGCOLOR 8 .

  DEFINE BUTTON BT-Later
       LABEL "Decide &Later" 
       SIZE 15 BY 1.14
       BGCOLOR 8 
       TOOLTIP "Suppress further prompts until scan is complete".

  DEFINE VARIABLE CB-value AS CHARACTER FORMAT "X(256)":U 
       LABEL "&1" 
       VIEW-AS COMBO-BOX INNER-LINES 5
       LIST-ITEMS "Item 1" 
       DROP-DOWN-LIST
       SIZE 25 BY 1 NO-UNDO.

  DEFINE VARIABLE EDITOR-1 AS CHARACTER INITIAL "More than one possible &1 was found for this object.&2Please choose a &1:"
       VIEW-AS EDITOR NO-BOX
       SIZE 75 BY 1.91 NO-UNDO.

  DEFINE VARIABLE FI-object AS CHARACTER FORMAT "X(256)":U 
        VIEW-AS TEXT 
       SIZE 31 BY .62 NO-UNDO.

  DEFINE VARIABLE RS-use-for AS CHARACTER 
       VIEW-AS RADIO-SET VERTICAL
       RADIO-BUTTONS 
            "Use this &1 for this file only", "this-file",
  "Use this &1 for all files with the same extension", "this-extension",
  "Use this &1 for any files with no other default", "any-file"
       SIZE 61 BY 3 NO-UNDO.


  /*
   Frame Definition
  */
  DEFINE FRAME Dialog-Frame
       EDITOR-1 AT ROW 2.43 COL 4 NO-LABEL
       CB-value AT ROW 5.05 COL 22
       RS-use-for AT ROW 6.48 COL 12 NO-LABEL
       BT-Ok AT ROW 10.52 COL 25
       BT-Cancel AT ROW 10.52 COL 43
       BT-Later  AT ROW 10.52 COL 61
       FI-object AT ROW 1.24 COL 2 COLON-ALIGNED NO-LABEL
       SPACE(41.13) SKIP(10.42)
      WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
           SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
           TITLE {&ALERT-TITLE}
           DEFAULT-BUTTON BT-Ok CANCEL-BUTTON BT-Cancel.

  ON CHOOSE OF BT-Later DO:
    Poption = "Later".
    APPLY "END-ERROR" TO FRAME Dialog-Frame.
  END.

  ON WINDOW-CLOSE OF FRAME Dialog-Frame DO:
    Poption = "Cancel".
    APPLY "END-ERROR":U TO SELF.
  END.

  /*
   Tailor for mode
  */
  ASSIGN FI-object:SCREEN-VALUE   = Pobject
         RS-use-for:RADIO-BUTTONS = SUBSTITUTE(RS-use-for:RADIO-BUTTONS,Pmode)
         CB-value:LIST-ITEMS      = Pvalues
         CB-Value:LABEL           = Pmode
         CB-Value:SCREEN-VALUE    = CB-Value:ENTRY(1).

  /*
   Display it
  */
  DISPLAY EDITOR-1 CB-value RS-use-for WITH FRAME Dialog-Frame.

  EDITOR-1:SCREEN-VALUE    = SUBSTITUTE(EDITOR-1:SCREEN-VALUE,Pmode,CHR(10)).

  ENABLE FI-object EDITOR-1 CB-value RS-use-for BT-Ok BT-Cancel BT-Later
      WITH FRAME Dialog-Frame.

  VIEW FRAME Dialog-Frame.

  WAIT-FOR GO OF FRAME Dialog-Frame.
  HIDE FRAME Dialog-Frame.

  IF NOT CAN-DO("Cancel,Later":U,Poption) THEN
    ASSIGN Pvalue = CB-value:SCREEN-VALUE
           Poption = RS-use-for:SCREEN-VALUE.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_default_pmod wWin 
PROCEDURE get_default_pmod PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Prompt user for product module to use for current object.
  Parameters:  INPUT Pfilename - Filename of current object
               OUTPUT Ppmod    - Product module selected by user
               OUTPUT Poption  - Assignemtn option selected by user (use for
               this file only, all files with same extension, or decide later).
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Pfilename AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Ppmod     AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Poption   AS CHARACTER   NO-UNDO.

  RUN get_default_dialog (INPUT Pfilename,
                          INPUT "Product Module":U,
                          INPUT Mdef-pmods,
                          OUTPUT Ppmod,
                          OUTPUT Poption).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_default_subtype wWin 
PROCEDURE get_default_subtype PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Determine code subtype to use for current object.
  Parameters:  INPUT Pfilename  - Filename of current object.
               INPUT Psubdir    - The subditectory path where file resides.
               OUTPUT Psub-type - Subtype determined by file properties or
                                  selected by user.
               OUTPUT Poption   - Assignement option selected by user (use for
                                   this file only, all files with same extension,
                                   or decide later).
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Pfilename AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER Psubdir   AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Psub-type AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Poption   AS CHARACTER   NO-UNDO.

  RUN get_valid_subtypes (INPUT Pfilename,
                          INPUT Psubdir,
                          OUTPUT Psub-type,
                          OUTPUT Poption).
  
  IF NUM-ENTRIES(Mdef-subtypes) > 1  AND Poption <> "Later":U THEN
    RUN get_default_dialog (INPUT Pfilename,
                            INPUT "Code Subtype":U,
                            INPUT Mdef-subtypes,
                            OUTPUT Psub-type,
                            OUTPUT Poption).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_part_names wWin 
PROCEDURE get_part_names PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Determine part names for specified object type and subtype.
  Parameters:  INPUT  Proot-path - Root path for object parts
               INPUT  Pwsmod     - Workspace module for object
               INPUT  Psub-type  - Code subtype for object
               INPUT  Pobjname   - Name for object
               INPUT  Pobj-type  - Object type for object
               OUTPUT Pparts     - Partnames for object
               OUTPUT Perror     - Error (if any)
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Proot-path  AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER Pwsmod      AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER Psub-type   AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER Pobjname    AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER Pobj-type   AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER Pparts      AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER Perror      AS CHARACTER NO-UNDO.

  /* Define Locals */
  DEFINE VARIABLE McolValues     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mext           AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mmodpath       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mobj-name      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-dirs     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-exts     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-parts    AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-suffixes AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi             AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mdot           AS INTEGER     NO-UNDO.



  IF DYNAMIC-FUNCTION('fnRtbFetchModuleRecord':U IN h_rtb_q_mod,Pwsmod) THEN
  parts-block:
  DO:
    ASSIGN Mmodpath = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_moddef,
                                               'directory':U),CHR(1)).

    IF Pobj-type = "doc" THEN DO:
      /*
       Generate name for objects having sub-type of "doc"
      */
      Pparts = (IF Proot-path <> "" THEN  Proot-path + "/" ELSE "")
               + (IF Mmodpath <> "" THEN Mmodpath + "/"ELSE "")
               + "doc/" 
               + Pobjname.

    END.
    ELSE DO:
      RUN set_subtype_query (Psub-type).
      IF Mcurrent-subtype <> "" THEN DO:

        /*
         Check extension of Pobjname for correctness
        */
        Mpart-exts = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                              'subtPart-Exts':U),CHR(1)).
        IF ENTRY(1,Mpart-exts) <> "" THEN DO:
          Mext = IF R-INDEX(Pobjname,".") > 0 
                    AND R-INDEX(Pobjname,".") < LENGTH(Pobjname) THEN
                   SUBSTRING(Pobjname,R-INDEX(Pobjname,".") + 1)
                 ELSE
                   "".
          IF Mext <> ENTRY(1,Mpart-exts) THEN DO:
              Perror = SUBSTITUTE("Object name '&1' has a bad extension.",Pobjname).
            LEAVE parts-block. 
          END.
        END.

        /*
         Remove extension (if any) from Pobjname to get Mobj-name
        */
        Mdot = INDEX(Pobjname,".") - 1.
        ASSIGN Mobj-name = IF Mdot > 0 THEN
                             SUBSTRING(Pobjname,1,Mdot)
                           ELSE
                             Pobjname.

        /*
         Now check and remove suffix from Mobj-name if any
        */
        Mpart-suffixes = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                                  'subtPart-suffixes':U),CHR(1)).

        IF ENTRY(1,Mpart-suffixes) <> "" THEN DO:
          IF SUBSTRING(Mobj-name,LENGTH(Mobj-name) 
             - LENGTH(ENTRY(1,Mpart-suffixes)) + 1) <> ENTRY(1,Mpart-suffixes) THEN DO:
            Perror = SUBSTITUTE("Object name '&1' has a bad suffix.",Mobj-name).
            LEAVE parts-block.
          END.

          Mobj-name = SUBSTRING(Mobj-name,1,LENGTH(Mobj-name) 
                      - LENGTH(ENTRY(1,Mpart-suffixes))).
        END.

        /*
         Mobj-name is now the base name from which other part names will be 
         constructed.
        */
        ASSIGN McolValues  = DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                              'subtParts,subtPart-dirs':U)
               Mpart-parts = ENTRY(2,McolValues,CHR(1))
               Mpart-dirs  = ENTRY(3,McolValues,CHR(1)).
        DO Mi = 1 TO 10:
           IF ENTRY(Mi,Mpart-parts) = "" THEN LEAVE.

           IF Mi > 1 THEN Pparts = Pparts + ",".

           Pparts = Pparts 
                  + (IF Proot-path <> "" 
                        THEN Proot-path + "/"
                        ELSE "")
                  + (IF Mmodpath <> "" 
                       THEN Mmodpath + "/"
                       ELSE "")
                  + (IF ENTRY(Mi,Mpart-dirs) <> "" 
                        THEN ENTRY(Mi,Mpart-dirs) + "/"
                        ELSE "").

           IF Mi = 1 THEN 
              Pparts = Pparts + Pobjname. /* Used because we may not know extension!*/
           ELSE 
              Pparts = Pparts 
                     + Mobj-name
                     + ENTRY(Mi,Mpart-suffixes)
                     + (IF ENTRY(Mi,Mpart-exts) <> "" 
                           THEN "." + ENTRY(Mi,Mpart-exts)
                           ELSE "").

        END.
      END. /* available rtb_subtype */
      ELSE 
        Perror = SUBSTITUTE("Subtype '&1' does not exist.",Psub-type).

    END. /* Pobj-type = doc */

  END. /* parts-block */
  ELSE
    Perror = SUBSTITUTE("Module definition '&1' does not exist.",Pwsmod).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get_valid_subtypes wWin 
PROCEDURE get_valid_subtypes PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Determine valid code subtype(s) for specified object.
  Parameters:  INPUT Pfilename  - File name of specified object.
               INPUT Psubdir    - Subdirectory path where file is located.
               OUTPUT Psub-type - Subtype determined by file properties or
                                  selected by user.
               OUTPUT Poption   - Assignement option selected by user (use for
                                   this file only, all files with same extension,
                                   or decide later).
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER Pfilename AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER Psubdir   AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Psub-type AS CHARACTER   NO-UNDO.
  DEFINE OUTPUT PARAMETER Poption   AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE Mvalid      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi          AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mx          AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mkeep       AS LOGICAL     NO-UNDO.

  /*
   Construct a list of possible (valid) subtypes for this object

   ** We start with 2, since the 1st entry of the combo-box is "All"
  */
  Mvalid = "".
  DO Mi = 2 TO NUM-ENTRIES(CB-sub-type:LIST-ITEMS IN FRAME {&FRAME-NAME}):
    /*
     Is file a valid subtype part?
    */           
    Mkeep = DYNAMIC-FUNCTION('fnRtbCheckValidSubtypePart':U,
                             CB-sub-type:ENTRY(Mi) IN FRAME {&FRAME-NAME},
                             Pfilename,
                             Mcurrent-wsmod,
                             Psubdir).
    IF Mkeep THEN
      Mvalid = Mvalid + (IF Mvalid = "" THEN "" ELSE ",")
               + CB-sub-type:ENTRY(Mi) IN FRAME {&FRAME-NAME}.

  END.  /* for each rtb_subtype */

  get-valid:
  DO:
    IF NUM-ENTRIES(Mvalid) = ? 
       OR NUM-ENTRIES(Mvalid) = 0 THEN DO:
      ASSIGN Psub-type     = ""
             Poption       = "this-file"
             Mdef-subtypes = "".
      LEAVE get-valid.
    END.

    /*
     Subtype with the most parts present takes the cake
    */
    DO Mi = 1 TO (NUM-ENTRIES(Mvalid) - 1):
      DO Mx = 2 TO NUM-ENTRIES(Mvalid):
        IF fnRtbSubtypePartsCount(ENTRY(Mi,Mvalid)) >
           fnRtbSubtypePartsCount(ENTRY(Mx,Mvalid)) THEN
          ENTRY(Mx,Mvalid) = "".
      END.
    END.

    Mdef-subtypes = "".
    DO Mi = 1 TO NUM-ENTRIES(Mvalid):
      IF ENTRY(Mi,Mvalid) <> "" THEN
        Mdef-subtypes = Mdef-subtypes + (IF Mdef-subtypes = "" THEN "" ELSE ",")
                        + ENTRY(Mi,Mvalid).
    END.

    IF NUM-ENTRIES(Mdef-subtypes) = 1 THEN DO:
      ASSIGN Psub-type = Mdef-subtypes
             Poption = "this-file":U.

      IF fnRtbSubtypePartsCount(Mdef-subtypes) > 1 THEN
        RUN remove_subtype_parts (INPUT Mdef-subtypes,
                                  INPUT Pfilename).

      LEAVE get-valid.
    END.  /* if num-entries(CB-sub-type ... */  

  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject wWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  DYNAMIC-FUNCTION('fnRtbPositionWindow':U,{&WINDOW-NAME}:HANDLE).

  /*
   Get session info
  */
  PUBLISH "evRtbGetSid":U (OUTPUT Msid).
  PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT Mwspace-id).

  DYNAMIC-FUNCTION('fnRtbSelectWorkspace':U IN h_rtb_q_mod,Mwspace-id).
  DYNAMIC-FUNCTION('fnRtbSelectActive':U IN h_rtb_u_subt). 

  /*
   Get prepared temp-table
  */
  RUN prepare_modload_temp_table IN h_rtb_u_obj (OUTPUT TABLE-HANDLE MhTTsrcfile).

  RUN initialize_browse.

  /*
   Fill combo-boxes
  */
  RUN fill_wsmod_combo.
  RUN fill_subtype_combo.

  RUN SUPER.

  DO WITH FRAME {&FRAME-NAME}:
    fnAddResizeable(FRAME {&FRAME-NAME}:HANDLE,TRUE,TRUE,FALSE,FALSE,FALSE).
    fnAddResizeable(rect-1:HANDLE,FALSE,TRUE,FALSE,FALSE,FALSE).
    fnAddResizeable(rect-2:HANDLE,TRUE,TRUE,FALSE,FALSE,FALSE).
    fnAddResizeable(BROWSE BR-SrcFile:HANDLE,TRUE,TRUE,FALSE,FALSE,FALSE).
    fnAddResizeable(BT-Select:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
    fnAddResizeable(BT-Deselect:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
    fnAddResizeable(BT-Properties:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
    fnAddResizeable(BT-View:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
    fnAddResizeable(BT-Load:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
    fnAddResizeable(BT-Delete:HANDLE,FALSE,FALSE,FALSE,TRUE,FALSE).
  END.

  RUN set_sensitive.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initialize_browse wWin 
PROCEDURE initialize_browse PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Initialize browse widget
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE MhBrowse AS HANDLE NO-UNDO.
  DEFINE VARIABLE MhCol    AS HANDLE NO-UNDO.

  ASSIGN MhBrowse  = BROWSE BR-srcfile:HANDLE
         MhSrcBuff = MhTTsrcfile:DEFAULT-BUFFER-HANDLE.

  CREATE QUERY MhSrcQry.
  MhSrcQry:SET-BUFFERS(MhSrcBuff).
  ASSIGN MhBrowse:READ-ONLY = NO
         MhBrowse:QUERY     = MhSrcQry.

  ASSIGN MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("obj-status":U))
         MhCol:WIDTH = 10.
         MhCol:READ-ONLY = YES.

  ASSIGN MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("module":U))
         MhCol:WIDTH = 50
         MhCol:READ-ONLY = YES.
         
  ASSIGN MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("object":U))
         MhCol:READ-ONLY = YES.

  ASSIGN MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("sub-type":U))
         MhCol:AUTO-RESIZE = YES
         MhCol:LABEL = "Subtype".
         
  ASSIGN MhSrcBuff:BUFFER-FIELD("pmod":U):VALIDATE-EXPRESSION = ""
         MhSrcBuff:BUFFER-FIELD("pmod":U):FORMAT              = "x(50)"
         MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("pmod":U))
         MhCol:AUTO-RESIZE = YES.

  ASSIGN MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("obj-group":U))
         MhCol:AUTO-RESIZE = YES.

  ASSIGN MhSrcBuff:BUFFER-FIELD("fullpath":U):FORMAT = "x(256)"
         MhCol = MhBrowse:ADD-LIKE-COLUMN(MhSrcBuff:BUFFER-FIELD("fullpath":U))
         MhCol:READ-ONLY = YES
         MhCol:AUTO-RESIZE = YES.

  ASSIGN MhBrowse:ALLOW-COLUMN-SEARCHING = TRUE
         MhBrowse:COLUMN-RESIZABLE       = TRUE.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE load_files_icf_post wWin 
PROCEDURE load_files_icf_post :
/*------------------------------------------------------------------------------
  Purpose:     Dynamics Enhancements
  Parameters:  <none>
  Notes:       Post events, after files have been loaded
------------------------------------------------------------------------------*/

  DEFINE OUTPUT PARAMETER opError     AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE cRTBProductModule   AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cSCMProductModule   AS CHARACTER  NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:
    ASSIGN
      cRTBProductModule = CB-module:SCREEN-VALUE
      cSCMProductModule = CB-module:SCREEN-VALUE.
  END.

  IF VALID-HANDLE(gshSessionManager)
  THEN DO:

    RUN getActionUnderway IN gshSessionManager
                         (INPUT  "SCM":U
                         ,INPUT  "SKIPLOADNO":U
                         ,INPUT  cRTBProductModule
                         ,INPUT  "":U
                         ,INPUT  "":U
                         ,INPUT  YES
                         ,OUTPUT lActionUnderway).
                         
    RUN getActionUnderway IN gshSessionManager
                         (INPUT  "SCM":U
                         ,INPUT  "SKIPLOADYES":U
                         ,INPUT  cRTBProductModule
                         ,INPUT  "":U
                         ,INPUT  "":U
                         ,INPUT  YES
                         ,OUTPUT lActionUnderway).

  END.

  ASSIGN
    opError = "":U.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE load_files_icf_pre wWin 
PROCEDURE load_files_icf_pre :
/*------------------------------------------------------------------------------
  Purpose:     Dynamics Specific Enhancements
  Parameters:  <none>
  Notes:       Pre events, before files are to be loaded
------------------------------------------------------------------------------*/

  DEFINE OUTPUT PARAMETER opError     AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE cRTBProductModule   AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cSCMProductModule   AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE Merror     AS CHARACTER   NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:
    ASSIGN
      cRTBProductModule = CB-module:SCREEN-VALUE
      cSCMProductModule = CB-module:SCREEN-VALUE.
  END.

  IF VALID-HANDLE(gshSessionManager)
  THEN DO:

    /* Product Module Enhancement - Begin */

    /* Check if SCMTool is running */
    ASSIGN 
      hScmTool = DYNAMIC-FUNCTION('getProcedureHandle':U IN THIS-PROCEDURE, INPUT 'PRIVATE-DATA:SCMTool':U) NO-ERROR
      .

    /* Default title values */
    ASSIGN
      cMesWinTitle            = "Module Load (Dynamics Enhancement)":U
      cMesWinButtonCancel     = "Cancel":U
      cMesWinAnswerValue      = "":U
      cMesWinAnswerDataType   = "":U
      cMesWinAnswerFormat     = "":U
      .

    /* This product module check should rather be moved to a API in ryscmevntp.p in the future */
    IF cSCMProductModule <> "":U
    THEN
      RUN scmSitePrefixDel IN hScmTool (INPUT-OUTPUT cSCMProductModule).

    FIND FIRST gsc_product_module NO-LOCK
      WHERE gsc_product_module.product_module_code = cSCMProductModule
      NO-ERROR.
    IF NOT AVAILABLE gsc_product_module
    THEN DO:

      /* Button values */
      ASSIGN
        cMesWinButtonList       = "Continue,Cancel":U
        cMesWinButtonDefault    = "Cancel":U
        .

      /* Warning */
      ASSIGN
        cMesWinMessage  = 'The product module (' + cRTBProductModule + ') does not exist in the Progress Dynamics repository (ICFDB)'
                        + CHR(10)
                        + 'If you answer "Continue",'
                        + CHR(10)
                        + ' - the object will only be stored in the Roundtable Repository.'
                        + CHR(10)
                        + ' - the object will not be register in the Progress Dynamics repository (ICFDB). Warning messages would be reveiced for each object it cannot register.'
                        + CHR(10)
                        + ' The objects must be manualy registered using the XML synchronization utility.'
                        + CHR(10)
                        + 'Continue with Load of objects even though the product module does not exist ? (usually choose "Cancel")'
                        .
      /* Try and display a nice formatted error if we can */
      RUN askQuestion IN gshSessionManager
                     (INPUT cMesWinMessage
                     ,INPUT cMesWinButtonList
                     ,INPUT cMesWinButtonDefault
                     ,INPUT cMesWinButtonCancel
                     ,INPUT ""
                     ,INPUT cMesWinAnswerDataType
                     ,INPUT cMesWinAnswerFormat
                     ,INPUT-OUTPUT cMesWinAnswerValue
                     ,OUTPUT cMesWinButtonPressed
                     ).

      IF LOOKUP(cMesWinButtonPressed,"Cancel":U) > 0
      THEN DO:
        ASSIGN
          opError = "Progress Dynamics Product Module":U + cRTBProductModule + "not available".
        RETURN.
      END.

    END.  /* if ERROR <> "" */

    /* Product Module Enhancement - End */

    /* Data Load Enhancement - Begin */

    /* Button values */
    ASSIGN
      cMesWinButtonList       = "Import All,Skip all,Decide Later,Cancel":U
      cMesWinButtonDefault    = "Import All":U
      .

    /* Question 01 */
    ASSIGN
      cMesWinMessage  = 'Do you wish to automatically import the objects information from the Progress Dynamics repository (ICFDB)'
                      + ' and create/update the content/information of the object from the .ado file containing the XML data.'
                      + CHR(10)
                      + 'If you choose "Decide Later", you will asked for each object if you wish to import it or not.'
                      + CHR(10)
                      + 'If you answer "Skip All", an INCORRECT version of the data could be stored in the Roundtable Repository.'
                      + ' This should ONLY be skipped if the correct version is already in the Dynamics Repository, i.e.'
                      + ' a new Dynamics Repository Database has been created/build and correctly loaded.'
                      + ' This could be done manually or by using the DCU installation/update utility.'
                      + CHR(10)
                      + 'Load the .ado XML files ? (usually choose "Import All")'
                      .
    /* Try and display a nice formatted error if we can */
    RUN askQuestion IN gshSessionManager
                   (INPUT cMesWinMessage
                   ,INPUT cMesWinButtonList
                   ,INPUT cMesWinButtonDefault
                   ,INPUT cMesWinButtonCancel
                   ,INPUT cMesWinTitle
                   ,INPUT cMesWinAnswerDataType
                   ,INPUT cMesWinAnswerFormat
                   ,INPUT-OUTPUT cMesWinAnswerValue
                   ,OUTPUT cMesWinButtonPressed
                   ).

    IF LOOKUP(cMesWinButtonPressed,"Skip All":U) > 0
    THEN DO:

      /* Question 02 */
      ASSIGN
        cMesWinMessage  = 'Are you really sure you know what you are doing and really do not want the Progress Dynamics enhancement. ' + 
                          'If you continue with this decision, then the INCORRECT version of data could be stored into Roundtable. ' + 
                          'So, to be sure we will ask again. ' + 
                          'Do you want to SKIP the Progress Dynamics enhancement and NOT load the .ado file ' + 
                          'containing the XML content/information of the object.' + "~n":U + "~n":U +
                          'Please obtain appropriate authorisation if you answer "Skip All" to this question.' + "~n":U + "~n":U +
                          'Load the .ado XML files ? (usually choose "Import All")'
                        .
      /* Try and display a nice formatted error if we can */
      RUN askQuestion IN gshSessionManager
                     (INPUT cMesWinMessage
                     ,INPUT cMesWinButtonList
                     ,INPUT cMesWinButtonDefault
                     ,INPUT cMesWinButtonCancel
                     ,INPUT cMesWinTitle
                     ,INPUT cMesWinAnswerDataType
                     ,INPUT cMesWinAnswerFormat
                     ,INPUT-OUTPUT cMesWinAnswerValue
                     ,OUTPUT cMesWinButtonPressed
                     ).

    END. /* "Skip All" */

    CASE cMesWinButtonPressed:
      WHEN cMesWinButtonCancel /* Cancel */
        THEN DO:
          Merror = "Progress Dynamics: Roundable Module Load Cancelled".
          MESSAGE 
            Merror
            VIEW-AS ALERT-BOX ERROR
            TITLE {&ALERT-TITLE}.
          RETURN.
        END.
      WHEN "Import All":U
        THEN
          RUN setActionUnderway IN gshSessionManager
                               (INPUT "SCM":U
                               ,INPUT "SKIPLOADNO":U
                               ,INPUT cRTBProductModule
                               ,INPUT "":U
                               ,INPUT "":U
                               ).
      WHEN "Skip All":U
        THEN
          RUN setActionUnderway IN gshSessionManager
                               (INPUT "SCM":U
                               ,INPUT "SKIPLOADYES":U
                               ,INPUT cRTBProductModule
                               ,INPUT "":U
                               ,INPUT "":U
                               ).
      OTHERWISE DO: /* DECIDE LATER */
        /* do nothing */
      END.
    END CASE.

    /* Data Load Enhancement - End */

  END. /* VALID-HANDLE(gshSessionManager) */

  ASSIGN
    opError = "":U.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE load_objects wWin 
PROCEDURE load_objects PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Create repository objects for selected temp-table records.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Merror      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MhLoadBuff  AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhLoadQry   AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhTopObjSdo AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhTTLoad    AS HANDLE      NO-UNDO.


  MESSAGE "Loading objects may take several minutes." SKIP(1)
          "Continue with load of selected objects?"
    VIEW-AS ALERT-BOX WARNING BUTTONS YES-NO TITLE {&ALERT-TITLE}
    UPDATE Mcontinue AS LOGICAL.

  IF Mcontinue THEN DO:

      /* Dynamics Enhancements - BEGIN */
      IF lICFRunning
      THEN DO:
        DEFINE VARIABLE cErrorPre AS CHARACTER  NO-UNDO.
        ASSIGN
          cErrorPre = "":U.
        RUN load_files_icf_pre (OUTPUT cErrorPre).
        IF cErrorPre <> "":U
        THEN RETURN.
      END.
      /* Dynamics Enhancements - END */

    STATUS DEFAULT "Loading selected objects...".

    SESSION:SET-WAIT-STATE("GENERAL":U).

    CREATE TEMP-TABLE MhTTLoad.
    MhTTLoad:CREATE-LIKE(MhSrcBuff).
    MhTTLoad:TEMP-TABLE-PREPARE("TTobjects").
    MhLoadBuff = MhTTLoad:DEFAULT-BUFFER-HANDLE.

    DO WITH FRAME {&FRAME-NAME}:
      DO Mi = 1 TO BR-srcfile:NUM-SELECTED-ROWS:
        BR-srcfile:FETCH-SELECTED-ROW(Mi).
        IF MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE = "New":U THEN DO:
          MhLoadBuff:BUFFER-CREATE.
          MhLoadBuff:BUFFER-COPY(MhSrcBuff).
        END.
      END.
    END.

    PUBLISH "evRtbGetCurrentTask":U (OUTPUT Mtask-num).

    RUN rtb_loadObjects IN h_rtb_u_obj (INPUT Msid,
                                        INPUT Mwspace-id,
                                        INPUT Mtask-num,
                                        INPUT-OUTPUT TABLE-HANDLE MhTTLoad, 
                                        OUTPUT Merror).
                              
    CREATE QUERY MhLoadQry.
    MhLoadQry:SET-BUFFERS(MhLoadBuff).
    MhLoadQry:QUERY-PREPARE("FOR EACH TTobjects":U).
    MhLoadQry:FORWARD-ONLY = TRUE.
    MhLoadQry:QUERY-OPEN.
    MhLoadQry:GET-FIRST.

    DO WHILE TRUE:
      IF MhLoadQry:QUERY-OFF-END THEN LEAVE.
      MhSrcBuff:FIND-FIRST(SUBSTITUTE("where module = '&1' and filename = '&2'",
                                      MhLoadBuff:BUFFER-FIELD("module":U):BUFFER-VALUE,
                                      MhLoadBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE)).
      IF MhSrcBuff:AVAILABLE THEN DO:
        ASSIGN MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE =
                 MhLoadBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE
               MhSrcBuff:BUFFER-FIELD("error":U):BUFFER-VALUE =
                 MhLoadBuff:BUFFER-FIELD("error":U):BUFFER-VALUE.
      END.
      MhLoadQry:GET-NEXT.
    END.

    DELETE OBJECT MhLoadQry.
    DELETE OBJECT MhTTLoad.

    BR-srcfile:REFRESH() IN FRAME {&FRAME-NAME}.
    RUN set_sensitive.

    /*
     Refresh Tabletop as required
    */
    PUBLISH "evRtbGetObjSdoHandle":U (OUTPUT MhTopObjSdo).
    IF VALID-HANDLE(MhTopObjSdo) THEN DO:
      DYNAMIC-FUNCTION('fnRtbSelectWorkspaceModule':U IN MhTopObjSdo,
                       Mwspace-id,Mcurrent-wsmod).
      APPLY "ENTRY":U TO {&WINDOW-NAME}.
    END.

    /* Dynamics Enhancements - BEGIN */
    IF lICFRunning
    THEN DO:
      DEFINE VARIABLE cErrorPost AS CHARACTER  NO-UNDO.
      ASSIGN
        cErrorPost = "":U.
      RUN load_files_icf_post (OUTPUT cErrorPost).
      IF cErrorPost <> "":U
      THEN RETURN.
    END.
    /* Dynamics Enhancements - END */

    SESSION:SET-WAIT-STATE("").

    STATUS DEFAULT.

    IF Merror <> "" THEN DO:
      MESSAGE Merror VIEW-AS ALERT-BOX ERROR TITLE {&ALERT-TITLE}.
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE open_data_file wWin 
PROCEDURE open_data_file PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Load temp-table from data file, replacing current data (if any).
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mdata     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mdatafile AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi        AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mcontinue AS LOGICAL     NO-UNDO.

  IF MhSrcBuff:AVAILABLE THEN 
    MESSAGE "Replace existing data with data from file?"
      VIEW-AS ALERT-BOX WARNING BUTTONS YES-NO
      TITLE {&ALERT-TITLE}
      UPDATE Mcontinue.
  ELSE
    Mcontinue = YES.

  IF Mcontinue THEN DO:
    IF MhSrcBuff:AVAILABLE THEN DO:
      /*
       Delete existing records
      */
      MhSrcBuff:EMPTY-TEMP-TABLE.
    END.

    /*
     Prompt for data file
    */
    SYSTEM-DIALOG GET-FILE Mdatafile
      TITLE      "Select data file to open ..."
      FILTERS    "Data Files (*.d)"   "*.d"
      MUST-EXIST
      UPDATE Mcontinue.

    IF Mcontinue THEN DO:

      STATUS DEFAULT "Loading data...".
      SESSION:SET-WAIT-STATE("GENERAL":U).

      /*
       Load the data
      */
      INPUT FROM VALUE(Mdatafile).

      REPEAT:
        IMPORT UNFORMATTED Mdata.
        MhSrcBuff:BUFFER-CREATE.
        /*
         Insert space-delimited values into corresponding buffer fields
        */
        DO Mi = 1 TO MhSrcBuff:NUM-FIELDS:
          MhSrcBuff:BUFFER-FIELD(Mi):BUFFER-VALUE = ENTRY(Mi,Mdata,CHR(32)).
          IF MhSrcBuff:BUFFER-FIELD(Mi):NAME = "module":U THEN
            Mcurrent-wsmod = MhSrcBuff:BUFFER-FIELD(Mi):BUFFER-VALUE.
        END.
      END.

      INPUT CLOSE.

      DO WITH FRAME {&FRAME-NAME}:
        IF CB-module:LOOKUP(Mcurrent-wsmod) = 0 THEN
          CB-module:ADD-LAST(Mcurrent-wsmod).
        CB-module:SCREEN-VALUE = Mcurrent-wsmod.
        RUN set_module_query (INPUT Mcurrent-wsmod).
        BROWSE BR-srcfile:REFRESH().
      END.
      RUN set_sensitive.

      SESSION:SET-WAIT-STATE("").
      STATUS DEFAULT.
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE remove_subtype_parts wWin 
PROCEDURE remove_subtype_parts PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Remove subordinate subtype parts for specified file from list.
  Parameters:  INPUT Pfilename AS CHARACTER
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Psub-type AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pfilename AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE Merror     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mfilename  AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mfullpath  AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mparts     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MhQuery3   AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhSrcBuff2 AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhSrcBuff3 AS HANDLE      NO-UNDO.

  CREATE BUFFER MhSrcBuff2 FOR TABLE MhSrcBuff.
  CREATE BUFFER MhSrcBuff3 FOR TABLE MhSrcBuff.

  MhSrcBuff2:FIND-FIRST(SUBSTITUTE("WHERE module = '&1' AND filename = '&2'",
                                   CB-module:SCREEN-VALUE IN FRAME {&FRAME-NAME},
                                   Pfilename)) NO-ERROR.

  IF MhSrcBuff2:AVAILABLE THEN DO:
    RUN get_part_names (INPUT  Mworking-dir,
                        INPUT  MhSrcBuff2:BUFFER-FIELD("module":U):BUFFER-VALUE,
                        INPUT  Psub-type,
                        INPUT  MhSrcBuff2:BUFFER-FIELD("filename":U):BUFFER-VALUE,
                        INPUT  "PCODE",
                        OUTPUT Mparts,
                        OUTPUT Merror).

    IF Merror = "" THEN DO:

      CREATE QUERY MhQuery3.
      MhQuery3:SET-BUFFERS(MhSrcBuff3).

      DO Mi = 2 TO NUM-ENTRIES(Mparts):
        IF ENTRY(Mi,Mparts) <> "" THEN DO:
          ASSIGN Mfullpath = REPLACE(ENTRY(Mi,Mparts),"~\","~/")
                 Mfilename = SUBSTRING(Mfullpath,R-INDEX(Mfullpath,"~/") + 1).

          MhQuery3:QUERY-CLOSE.
          MhQuery3:QUERY-PREPARE(SUBSTITUTE("FOR EACH &1 WHERE module = '&2' AND filename = '&3'",
                                            MhTTsrcfile:NAME,
                                            CB-module:SCREEN-VALUE IN FRAME {&FRAME-NAME},
                                            Mfilename)).
          MhQuery3:FORWARD-ONLY = TRUE.
          MhQuery3:QUERY-OPEN.
          MhQuery3:GET-FIRST.

          DO WHILE TRUE:
            IF MhQuery3:QUERY-OFF-END THEN LEAVE.
          
            IF REPLACE(MhSrcBuff3:BUFFER-FIELD("fullpath":U):BUFFER-VALUE,
                       "~\","~/") = Mfullpath THEN DO:
              CREATE Tsubtype-parts.
              ASSIGN Tsubtype-parts.module    = MhSrcBuff3:BUFFER-FIELD("module":U):BUFFER-VALUE
                     Tsubtype-parts.filename  = Pfilename
                     Tsubtype-parts.partname  = MhSrcBuff3:BUFFER-FIELD("filename":U):BUFFER-VALUE.
              MhSrcBuff3:BUFFER-DELETE.
            END.
            MhQuery3:GET-NEXT.
          END. /* do while true */
        END.
      END. /* do mi... */
    END. /* if merror = "" */
  END. /* MhSrcBuff2:available */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE save_data_file wWin 
PROCEDURE save_data_file PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Save temp-table contents to a data file.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mdata     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mdatafile AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi        AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mcontinue AS LOGICAL     NO-UNDO.

  /*
   Prompt for data file
  */
  SYSTEM-DIALOG GET-FILE Mdatafile
    SAVE-AS
    ASK-OVERWRITE
    TITLE      "Save Module Load data as..."
    FILTERS    "Data Files (*.d)"   "*.d"
    UPDATE Mcontinue.

  IF Mcontinue THEN DO:

    SESSION:SET-WAIT-STATE("GENERAL":U).

    MhSrcQry:QUERY-CLOSE.
    MhSrcQry:QUERY-PREPARE(SUBSTITUTE("for each &1",MhTTsrcfile:NAME)).
    MhSrcQry:FORWARD-ONLY = TRUE.
    MhSrcQry:QUERY-OPEN.
    MhSrcQry:GET-FIRST.

    OUTPUT TO VALUE(Mdatafile).

    DO WHILE TRUE:
      IF MhSrcQry:QUERY-OFF-END THEN LEAVE.
      Mdata = "".
      DO Mi = 1 TO MhSrcBuff:NUM-FIELDS:
        Mdata = Mdata + (IF Mdata = "" THEN "" ELSE " ")
                + STRING(MhSrcBuff:BUFFER-FIELD(Mi):BUFFER-VALUE).
      END.
      PUT UNFORMATTED Mdata SKIP.
      MhSrcQry:GET-NEXT.
    END.

    OUTPUT CLOSE.

    SESSION:SET-WAIT-STATE("").

  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scan_all_directories wWin 
PROCEDURE scan_all_directories PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Scan directories for unloaded object files of all modules 
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mmsg     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mitem    AS INTEGER     NO-UNDO.

  ASSIGN Mpmod-prompt    = YES
         Msubtype-prompt = YES.
  
  STATUS DEFAULT "Scanning module directories.  Please wait...".
  SESSION:SET-WAIT-STATE("General").

  DO WITH FRAME {&FRAME-NAME}:

    DO Mitem = 1 TO CB-module:NUM-ITEMS:
   
      RUN build_source_list (INPUT CB-module:ENTRY(Mitem),
                             INPUT RS-scan-by:SCREEN-VALUE,
                             INPUT FI-filespec:SCREEN-VALUE,
                             INPUT CB-sub-type:SCREEN-VALUE).
      
      ASSIGN 
        Mcurrent-wsmod = CB-module:ENTRY(Mitem)
        Mdef-pmods     = DYNAMIC-FUNCTION('fnRtbGetWorkspaceSourceSitePmods':U IN h_rtb_u_wspmod,
                                           Mwspace-id,CB-module:ENTRY(Mitem)).
      /*
       Fill the list with pmods and subtypes
      */
      RUN fill_defaults.
    
    END. /* do mitem */

    /*
     If no unloaded items were found then message user.
    */
    MhSrcBuff:FIND-FIRST("",NO-LOCK) NO-ERROR.

    IF NOT MhSrcBuff:AVAILABLE THEN DO:

      Mmsg = SUBSTITUTE("No source code files matching &1 '&2' exist in or~
 below &3 that have not already been loaded into Roundtable.",
       RS-scan-by:SCREEN-VALUE,
       (IF RS-scan-by:SCREEN-VALUE = "Filespec":U THEN
         FI-filespec:SCREEN-VALUE
       ELSE
         CB-sub-type:SCREEN-VALUE),
       Mworking-dir).

     MESSAGE Mmsg VIEW-AS ALERT-BOX INFORMATION TITLE {&ALERT-TITLE}.

    END.

    /*
     Open query and browser
    */
    RUN set_all_query.

    MhSrcQry:REPOSITION-TO-ROW(1).
    Br-srcfile:MAX-DATA-GUESS = Msrcfile-entries.

  END. /* do with frame */

  /*
   End wait, hide message
  */
  STATUS DEFAULT.
  SESSION:SET-WAIT-STATE("").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scan_directories wWin 
PROCEDURE scan_directories PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Scan directories for unloaded object files
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mmsg     AS CHARACTER   NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:

    RUN build_source_list (INPUT CB-module:SCREEN-VALUE,
                           INPUT RS-scan-by:SCREEN-VALUE,
                           INPUT FI-filespec:SCREEN-VALUE,
                           INPUT CB-sub-type:SCREEN-VALUE).
    /*
     Fill the list with pmods and subtypes
    */
    ASSIGN Mpmod-prompt    = YES
           Msubtype-prompt = YES.
    RUN fill_defaults.

    MhSrcBuff:FIND-FIRST(SUBSTITUTE("where module = &1",CB-module:SCREEN-VALUE),
                        NO-LOCK) NO-ERROR.

    IF NOT MhSrcBuff:AVAILABLE THEN DO:

      Mmsg = SUBSTITUTE("No source code files matching &1 '&2' exist in or~
 below &3 that have not already been loaded into Roundtable.",
       RS-scan-by:SCREEN-VALUE,
       (IF RS-scan-by:SCREEN-VALUE = "Filespec":U THEN
         FI-filespec:SCREEN-VALUE
       ELSE
         CB-sub-type:SCREEN-VALUE),
       Mworking-dir).

     MESSAGE Mmsg VIEW-AS ALERT-BOX INFORMATION TITLE {&ALERT-TITLE}.

    END.

  END.

  RUN set_sensitive.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scan_for_comments wWin 
PROCEDURE scan_for_comments PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Scan an O/S file for comments and return a summary description
               and a detailed description of the file being scanned.
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mchr           AS CHARACTER           NO-UNDO.
  DEFINE VARIABLE Mdetailed-desc AS CHARACTER           NO-UNDO.
  DEFINE VARIABLE Mfullpath      AS CHARACTER           NO-UNDO.
  DEFINE VARIABLE Mlast-chr      AS CHARACTER           NO-UNDO.
  DEFINE VARIABLE Mline          AS CHARACTER EXTENT 12 NO-UNDO.   
  DEFINE VARIABLE Msummary-desc  AS CHARACTER           NO-UNDO.
  DEFINE VARIABLE Mchars         AS INTEGER             NO-UNDO.
  DEFINE VARIABLE Mcom-level     AS INTEGER             NO-UNDO.
  DEFINE VARIABLE Mx             AS INTEGER             NO-UNDO.

  IF MhSrcBuff:AVAILABLE THEN DO:
    /*
     Ensure file exists in O/S
    */
    Mfullpath = MhSrcBuff:BUFFER-FIELD("fullpath":U):BUFFER-VALUE.
    IF SEARCH(Mfullpath) = ? THEN DO:
      ASSIGN Msummary-desc  = ""
             Mdetailed-desc = "".
    END.  /* if search(pfilename) = ? */ 
    ELSE DO:
      /*
       Ensure that file is not binary
      */
      IF NOT DYNAMIC-FUNCTION('fnRtbIsBinaryFile':U,Mfullpath) THEN DO:
        /*
         Scan source for comment
        */
        INPUT FROM VALUE(Mfullpath) NO-ECHO.

        ASSIGN Mcom-level = 0
               Mx         = 1
               Mlast-chr  = ""
               Mchr       = ""
               Mline      = "".

        READBLK:
        /*
         Stop after the first 2000 chars, otherwise this can be slow.
        */
        REPEAT Mchars = 1 TO 2000:
          READKEY.
          ASSIGN Mchr = CHR(LASTKEY).

          IF Mcom-level = 0 THEN DO:
            IF Mlast-chr = "/" AND Mchr = "*" THEN DO:
              ASSIGN Mlast-chr = ""
                     Mcom-level = 1.
              NEXT.
            END.  /* if mlast-chr = "/" and ... */
            IF LASTKEY < 0 THEN LEAVE READBLK.
            ASSIGN Mlast-chr = Mchr.
            NEXT.
          END. /* Mcom-level = 0 */
          ELSE DO:
            IF LASTKEY = 13 OR LASTKEY < 0 THEN DO:
              IF ASC(Mlast-chr) > 31 AND ASC(Mlast-chr) < 127 THEN
                ASSIGN Mline[Mx] = Mline[Mx] + Mlast-chr. 
              ASSIGN Mx = Mx + 1.
              IF Mx > 12 OR LASTKEY < 0 THEN LEAVE READBLK.
              ASSIGN Mlast-chr = CHR(13).
            END.  /* if lastkey = 13 or lastkey < 0 */
            IF Mlast-chr = "*" AND Mchr = "/" THEN  DO: 
              /*
               Reduce com level
              */
              ASSIGN Mcom-level = Mcom-level - 1.
             
              IF Mcom-level = 0 THEN DO:
                ASSIGN Mlast-chr = ""
                       Mx = Mx + 1.   
                IF Mx > 12 THEN LEAVE.
                NEXT.
              END.  /* if mcom-level = 0 */
            END.  /* if last-chr = "*" and ... */
           
            IF Mlast-chr = "/" AND Mchr = "*" THEN
              ASSIGN Mcom-level = Mcom-level + 1.
            IF ASC(Mlast-chr) > 31 AND ASC(Mlast-chr) < 127 THEN
              ASSIGN  Mline[Mx] = Mline[Mx] + Mlast-chr.
            ASSIGN Mlast-chr = Mchr.
          END.  /* else do */
        END.  /* READBLK repeat */

        INPUT CLOSE.                          

        /*
         Assign descriptions
        */  
        ASSIGN Msummary-desc  = STRING(Mline[1],"x(40)").
        DO Mx = 1 TO 12: 
          Mdetailed-desc = Mdetailed-desc + Mline[Mx].
        END.  /* do mx = 1 to 12 */

        ASSIGN MhSrcBuff:BUFFER-FIELD("summary-desc":U):BUFFER-VALUE  = Msummary-desc
               MhSrcBuff:BUFFER-FIELD("detailed-desc":U):BUFFER-VALUE = Mdetailed-desc.

      END. /* not binary */

    END. /* else do (search) */

  END. /* mhsrcbuff:available */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE select_files wWin 
PROCEDURE select_files PRIVATE :
/*------------------------------------------------------------------------------
  Purpose: prompt user for filenames that match other files and either
           select or deselect these file..     
  Parameters:  Mselect-type: either "select" or "deselect"
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Mselect-type AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mfile        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi           AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mdeselected  AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mselected    AS INTEGER     NO-UNDO.

  DEFINE VARIABLE Mmessage    AS CHARACTER
    VIEW-AS EDITOR 
    INNER-LINES 8
    INNER-CHARS 74
    NO-BOX
    NO-UNDO.

  DEFINE BUTTON BT-Cancel AUTO-END-KEY 
       LABEL "&Cancel" 
       SIZE 15 BY 1.14
       BGCOLOR 8 .

  DEFINE BUTTON BT-Ok AUTO-GO 
       LABEL "&OK" 
       SIZE 15 BY 1.14
       BGCOLOR 8 .

  DEFINE FRAME matches-frame
    Mmessage
      NO-LABEL
      AT ROW 2 COL 2
    Mfile FORMAT "x(20)"
      LABEL "Matching Criteria"
      AT ROW 8.5 COL 10
      HELP "Enter file name with wildcard values."
      VIEW-AS FILL-IN
    BT-Ok AT ROW 10.52 COL 25
    BT-Cancel AT ROW 10.52 COL 43
  WITH
    VIEW-AS DIALOG-BOX
    SIZE 80 BY 13
    FONT 4
    SIDE-LABELS
    THREE-D
    TITLE {&ALERT-TITLE}.      


   Mmessage = SUBSTITUTE("Enter matching criteria for Filenames to &1 in~
 browse.&2&2    Example criteria:&2&2        *          : Matches~
 all files.&2        string*  : Matches all files that begin with 'string'.~
 &2        *~~.ext  : Matches all files that end with '.ext'.",~
 Mselect-type,CHR(10)).


  select-files:
  DO ON ERROR UNDO, LEAVE:
    /*
     Ensure that there are files in the browse
    */
    IF TB-Scan-All-Mods:CHECKED IN FRAME {&FRAME-NAME} THEN
      MhSrcBuff:FIND-FIRST("") NO-ERROR.
    ELSE
      MhSrcBuff:FIND-FIRST(SUBSTITUTE("WHERE module = '&1'",
                                      CB-module:SCREEN-VALUE IN FRAME {&FRAME-NAME}))
                NO-ERROR.
    
    IF NOT MhSrcBuff:AVAILABLE THEN DO:
      MESSAGE 
        "Cannot select any files as no files exist in the browse."
        VIEW-AS ALERT-BOX ERROR
        TITLE {&ALERT-TITLE}.
      LEAVE select-files.
    END.

    /*
     Go trigger
    */
    ON GO OF FRAME matches-frame
      ASSIGN Mfile.

    /*
     Close trigger
    */
    ON WINDOW-CLOSE OF FRAME matches-frame
      ASSIGN Mfile = "".

    ENABLE ALL WITH FRAME matches-frame.
    Mmessage:READ-ONLY IN FRAME matches-frame = YES.
    DISPLAY Mmessage WITH FRAME matches-frame.  

    ASSIGN Mfile:SCREEN-VALUE = "*".

    APPLY "ENTRY" TO Mfile IN FRAME matches-frame.
                                   
    DO ON ENDKEY UNDO, LEAVE 
       ON ERROR  UNDO, LEAVE:
      WAIT-FOR WINDOW-CLOSE, GO OF FRAME matches-frame.
    END.                 

    HIDE FRAME matches-frame.

    IF Mfile = "" OR Mfile = ? THEN LEAVE select-files.

    SESSION:SET-WAIT-STATE("GENERAL":U).

    MhSrcQry:GET-FIRST.

    DO WITH FRAME {&FRAME-NAME}:

      IF Mselect-type = "select" THEN DO WHILE TRUE:
        IF MhSrcQry:QUERY-OFF-END THEN LEAVE.
        IF MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE MATCHES Mfile THEN DO:
          MhSrcQry:REPOSITION-TO-ROWID(MhSrcBuff:ROWID).
          BR-srcfile:SELECT-FOCUSED-ROW().
        END.
        MhSrcQry:GET-NEXT.
      END.
      ELSE DO:
        ASSIGN Mselected   = BR-srcfile:NUM-SELECTED-ROWS
               Mdeselected = 0.
        DO Mi = 1 TO Mselected:
          BR-srcfile:FETCH-SELECTED-ROW(Mi - Mdeselected).
          IF MHSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE MATCHES Mfile THEN DO:
            BR-srcfile:DESELECT-SELECTED-ROW(Mi - Mdeselected).
            Mdeselected = Mdeselected + 1.
          END.
        END.
      END.

      /*
       Reposititon browse to currently selected row
      */
      BR-srcfile:SET-REPOSITIONED-ROW(Mcurrent-row).
      MhSrcQry:REPOSITION-TO-ROWID(Mcurrent-rowid).
      APPLY "ENTRY" TO BR-srcfile.
    END.

    SESSION:SET-WAIT-STATE("").

    RUN set_sensitive.

  END. /* select-files */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_all_query wWin 
PROCEDURE set_all_query PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     (Re)set temp-table's query to objects in all workspace
               modules.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  MhSrcQry:QUERY-CLOSE().
  MhSrcQry:QUERY-PREPARE(SUBSTITUTE("for each &1 ",MhTTsrcfile:NAME)).
  MhSrcQry:QUERY-OPEN.

  APPLY "VALUE-CHANGED":U TO BR-srcfile IN FRAME {&FRAME-NAME}.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_module_query wWin 
PROCEDURE set_module_query PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     (Re)set temp-table's query to objects for specified workspace
               module.
  Parameters:  INPUT Pmodule - Workspace module to query
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pmodule AS CHARACTER   NO-UNDO.

  MhSrcQry:QUERY-CLOSE().
  MhSrcQry:QUERY-PREPARE(SUBSTITUTE("for each &1 where module = '&2'",
                                    MhTTsrcfile:NAME,Pmodule)).
  MhSrcQry:QUERY-OPEN.

  ASSIGN Mcurrent-wsmod = Pmodule
         Mdef-pmods     = DYNAMIC-FUNCTION('fnRtbGetWorkspaceSourceSitePmods':U
                                             IN h_rtb_u_wspmod,
                                           Mwspace-id,Pmodule).

  APPLY "VALUE-CHANGED":U TO BR-srcfile IN FRAME {&FRAME-NAME}.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_object_properties wWin 
PROCEDURE set_object_properties PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Set object properties (pmod, subtype, group, etc.) for selected
               object(s).
  Parameters:  <none>
  Notes:       Build a list of values to pass to object properties window and
               update accordingly on return.
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mdummy      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MinitValues AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MnewValues  AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mproperty   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mvalue      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi          AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mx          AS INTEGER     NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:

    IF BR-srcfile:NUM-SELECTED-ROWS > 1 THEN DO:
      MinitValues = "sub-type":U + CHR(3)
                    + SUBSTRING(CB-sub-type:LIST-ITEMS,LENGTH(" All,":U) + 1)
                    + CHR(4) + "multiple-mods":U + CHR(3) + STRING(fnMultipleModsSelected()).
    END.
    ELSE DO:
      /*
       Set this to YES to only show valid subtypes on the properties window
      */
      DEFINE VARIABLE MvalidSubtypesOnly AS LOGICAL NO-UNDO INITIAL NO.
      
      BR-srcfile:FETCH-SELECTED-ROW(1).
      
      MinitValues = "object" + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("object":U):BUFFER-VALUE.
      
      IF MvalidSubtypesOnly THEN DO:

        RUN get_valid_subtypes
          (INPUT MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE,
           INPUT MhSrcBuff:BUFFER-FIELD("subdir":U):BUFFER-VALUE,
           OUTPUT Mdummy,
           OUTPUT Mdummy).

        MinitValues = MinitValues +
                      CHR(4) + "sub-type":U + CHR(3) + Mdef-subtypes.
      END.
      ELSE
        MinitValues = MinitValues +
                      CHR(4) + "sub-type":U + CHR(3) + SUBSTRING(CB-sub-type:LIST-ITEMS,LENGTH(" All,":U) + 1).

      MinitValues = MinitValues
                    + CHR(4)
                    + "obj-group":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("obj-group":U):BUFFER-VALUE
                    + CHR(4)
                    + "group-level":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("group-level":U):BUFFER-VALUE
                    + CHR(4)
                    + "summary-desc":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("summary-desc":U):BUFFER-VALUE
                    + CHR(4)
                    + "detailed-desc":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("detailed-desc":U):BUFFER-VALUE
                    + CHR(4)
                    + "obj-status":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE
                    + CHR(4)
                    + "error":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("error":U):BUFFER-VALUE. 
    END.

    IF TB-Scan-All-Mods:CHECKED THEN
      Mdef-pmods  = DYNAMIC-FUNCTION('fnRtbGetWorkspaceSourceSitePmods':U IN h_rtb_u_wspmod,
                                     Mwspace-id,
                                     MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE).
    
    MinitValues = MinitValues + CHR(4)
                  + "pmod":U  + CHR(3) + Mdef-pmods.

    BR-srcfile:FETCH-SELECTED-ROW(1).
    /*
     If valid subtype currently assigned to object, then pass it as
     the default value
    */
    IF MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE <> "" 
       AND LOOKUP(MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE,
                  Mdef-subtypes) > 0 THEN
      MinitValues = MinitValues + CHR(4) + "def-sub-type":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE.
    /*
     Pass currently assigned pmod as default value
    */
    IF MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE <> "" THEN
      MinitValues = MinitValues + CHR(4) + "def-pmod":U + CHR(3)
                    + MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE.

    /*
     Get new properties
    */
    RUN rtb/w/rtb_modprop.w (INPUT MinitValues,
                             OUTPUT MnewValues).

    /*
     Set new properties for each selected object
    */
    IF MnewValues <> "" THEN DO:
      DO Mi = 1 TO Br-srcfile:NUM-SELECTED-ROWS:
        BR-srcfile:FETCH-SELECTED-ROW(Mi).
        DO Mx = 1 TO NUM-ENTRIES(MnewValues,CHR(4)).
          ASSIGN Mproperty = ENTRY(1,ENTRY(Mx,MnewValues,CHR(4)),CHR(3))
                 Mvalue    = ENTRY(2,ENTRY(Mx,MnewValues,CHR(4)),CHR(3)).
          
          IF Mproperty = "group-level":U THEN
            MhSrcBuff:BUFFER-FIELD("group-level":U):BUFFER-VALUE = INTEGER(Mvalue).
          ELSE
            MhSrcBuff:BUFFER-FIELD(Mproperty):BUFFER-VALUE = Mvalue.
        END.
        /*
         Remove records now a part of another object via subtype change
        */
        RUN remove_subtype_parts
          (INPUT MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE,
           INPUT MhSrcBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE).
      END.
      BR-srcfile:REFRESH().
      BR-srcfile:SET-REPOSITIONED-ROW(Mcurrent-row).
      MhSrcQry:REPOSITION-TO-ROWID(Mcurrent-rowid).
    END.

  END.

  RUN set_sensitive.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_sensitive wWin 
PROCEDURE set_sensitive PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Set UI sensitivity as appropriate.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mwhere        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi            AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Many-selected AS LOGICAL     NO-UNDO.
  DEFINE VARIABLE Mdelete       AS LOGICAL     NO-UNDO.
  DEFINE VARIABLE Mfiles        AS LOGICAL     NO-UNDO.
  DEFINE VARIABLE Mload         AS LOGICAL     NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:

    IF TB-Scan-All-Mods:CHECKED THEN
      MhSrcBuff:FIND-FIRST("",NO-LOCK) NO-ERROR.
    ELSE
      MhSrcBuff:FIND-FIRST(SUBSTITUTE("where module = '&1'",CB-module:SCREEN-VALUE),
                           NO-LOCK) NO-ERROR.
    ASSIGN
      Many-selected = BR-srcfile:NUM-SELECTED-ROWS > 0
      Mfiles        = MhSrcBuff:AVAILABLE
      Mload         = Many-selected
      Mdelete       = Many-selected.

    DO Mi = 1 TO BR-srcfile:NUM-SELECTED-ROWS:

      BR-srcfile:FETCH-SELECTED-ROW(Mi).

      IF Mload THEN DO:
        IF MhSrcBuff:BUFFER-FIELD("obj-status"):BUFFER-VALUE = "New":U THEN DO:
          IF (MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE = ?
              OR MhSrcBuff:BUFFER-FIELD("sub-type":U):BUFFER-VALUE = ""
              OR MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE = ?
              OR MhSrcBuff:BUFFER-FIELD("pmod":U):BUFFER-VALUE = "") THEN
            Mload = NO.
        END.
        ELSE
          Mload = NO.
      END.

      IF Mdelete
         AND MhSrcBuff:BUFFER-FIELD("obj-status"):BUFFER-VALUE <> "Done":U THEN
        Mdelete = NO.

      IF Mload = NO AND Mdelete = NO THEN LEAVE.

    END.

    /*
     Enable/disable frame widgets
    */
    ASSIGN BT-properties:SENSITIVE    = Many-selected AND Mfiles
           BT-load:SENSITIVE          = Many-selected AND Mload AND Mfiles
           BT-delete:SENSITIVE        = Many-selected AND Mdelete AND Mfiles
           BT-view:SENSITIVE          = (BR-srcfile:NUM-SELECTED-ROWS = 1)
           BT-select:SENSITIVE        = Mfiles
           BT-deselect:SENSITIVE      = Many-selected
           BT-clear:SENSITIVE         = Mfiles
           FI-filespec:TAB-STOP       = RS-scan-by:SCREEN-VALUE = "Filespec":U
           FI-filespec:READ-ONLY      = RS-scan-by:SCREEN-VALUE = "Subtype":U
           CB-sub-type:SENSITIVE      = RS-scan-by:SCREEN-VALUE = "Subtype":U
           CB-module:SENSITIVE        = NOT TB-Scan-All-Mods:CHECKED
           BROWSE BR-srcfile:TAB-STOP = Mfiles.

    ASSIGN MENU-ITEM m_Save_Data:SENSITIVE             IN MENU MENU-BAR-wWin = Mfiles
           MENU-ITEM m_File_Properties:SENSITIVE       IN MENU MENU-BAR-wWin = BT-properties:SENSITIVE
           MENU-ITEM m_Load_Selected_Files:SENSITIVE   IN MENU MENU-BAR-wWin = BT-load:SENSITIVE
           MENU-ITEM m_Unload_Selected_Files:SENSITIVE IN MENU MENU-BAR-wWin = BT-delete:SENSITIVE
           MENU-ITEM m_File_View:SENSITIVE             IN MENU MENU-BAR-wWin = BT-View:SENSITIVE
           MENU-ITEM m_Select_Files:SENSITIVE          IN MENU MENU-BAR-wWin = Mfiles
           MENU-ITEM m_Deselect_Files:SENSITIVE        IN MENU MENU-BAR-wWin = Many-selected
           SUB-MENU m_Search:SENSITIVE                 IN MENU MENU-BAR-wWin = Mfiles.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_subtype_query wWin 
PROCEDURE set_subtype_query PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Select specified code subtype in corresponding SDO.
  Parameters:  INPUT Psub-type - Code subtype to query.
  Notes:       All active Subtypes were fetched into the client RowObject
               table during initialization of this window (initializeObject).
               This procedure simply positions the client-side RowObject
               table to the specified Subtype row (if available).
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Psub-type AS CHARACTER   NO-UNDO.
  
  DEFINE VARIABLE hBuf    AS HANDLE      NO-UNDO.
  
  ASSIGN
    Psub-type = TRIM(Psub-type)
    hBuf      = DYNAMIC-FUNCTION('getRowObject' IN h_rtb_u_subt).
    
  IF hBuf:FIND-FIRST("WHERE sub-type = " + QUOTER(Psub-type),NO-LOCK) THEN
    Mcurrent-subtype = Psub-type.
  ELSE
    Mcurrent-subtype = "".

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_working_directory wWin 
PROCEDURE set_working_directory PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Get root directory to scan for objects
  Parameters:  <none>
  Notes:       If current task share-status is not Central, use the task
               directory; otherwise use the workspace root directory.
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mshare-status AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mwspace-id    AS CHARACTER   NO-UNDO.

  /*
   Determine current task's share status
  */
  PUBLISH "evRtbGetCurrentTask":U (OUTPUT Mtask-num).
  DYNAMIC-FUNCTION('fnRtbSelectTask':U IN h_rtb_u_task, INPUT Mtask-num).
  Mshare-status = TRIM(DYNAMIC-FUNCTION('columnStringValue':U IN h_rtb_u_task,
                                        'share-status':U)).

  /*
   If share status is not Central, use the task directory
  */
  IF Mshare-status <> "Central" THEN
    Mworking-dir = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_task,
                                            'task-directory':U),CHR(1)).
  /*
   Else use the workspace root directory
  */
  ELSE DO:
    Mwspace-id = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_task,
                                          'wspace-id':U),CHR(1)).
    DYNAMIC-FUNCTION('fnRtbSelectWorkspace':U IN h_rtb_q_ws,Mwspace-id).
    Mworking-dir = ENTRY(1,ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_q_ws,
                                                    'wspace-path':U),CHR(1))).
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE unload_objects wWin 
PROCEDURE unload_objects PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Remove selected object(s) from repository.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Merror      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MhLoadBuff  AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhLoadQry   AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhTopObjSdo AS HANDLE      NO-UNDO.
  DEFINE VARIABLE MhTTLoad    AS HANDLE      NO-UNDO.


  MESSAGE "Unloading object may take several minutes." SKIP(1)
          "Continue with unload of the selected objects?"
    VIEW-AS ALERT-BOX WARNING BUTTONS YES-NO TITLE {&ALERT-TITLE}
    UPDATE Mcontinue AS LOGICAL.

  IF Mcontinue THEN DO:
    STATUS DEFAULT "Unloading selected objects...".

    SESSION:SET-WAIT-STATE("GENERAL":U).

    CREATE TEMP-TABLE MhTTLoad.
    MhTTLoad:CREATE-LIKE(MhSrcBuff).
    MhTTLoad:TEMP-TABLE-PREPARE("TTobjects").
    MhLoadBuff = MhTTLoad:DEFAULT-BUFFER-HANDLE.

    DO WITH FRAME {&FRAME-NAME}:
      DO Mi = 1 TO BR-srcfile:NUM-SELECTED-ROWS:
        BR-srcfile:FETCH-SELECTED-ROW(Mi).
        IF MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE = "Done":U THEN DO:
          MhLoadBuff:BUFFER-CREATE.
          MhLoadBuff:BUFFER-COPY(MhSrcBuff).
        END.
      END.
    END.

    Merror = DYNAMIC-FUNCTION('fnRtbUnloadObjects':U IN h_rtb_u_obj,
                              INPUT Msid,
                              INPUT Mwspace-id,
                              INPUT Mtask-num,
                              INPUT-OUTPUT TABLE-HANDLE MhTTLoad).
                              
    CREATE QUERY MhLoadQry.
    MhLoadQry:SET-BUFFERS(MhLoadBuff).
    MhLoadQry:QUERY-PREPARE("FOR EACH TTobjects":U).
    MhLoadQry:FORWARD-ONLY = TRUE.
    MhLoadQry:QUERY-OPEN.
    MhLoadQry:GET-FIRST.

    DO WHILE TRUE:
      IF MhLoadQry:QUERY-OFF-END THEN LEAVE.
      IF MhLoadBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE = "New":U THEN DO:
        MhSrcBuff:FIND-FIRST(SUBSTITUTE("where module = '&1' and filename = '&2'",
                                        MhLoadBuff:BUFFER-FIELD("module":U):BUFFER-VALUE,
                                        MhLoadBuff:BUFFER-FIELD("filename":U):BUFFER-VALUE)).
        IF MhSrcBuff:AVAILABLE THEN
          MhSrcBuff:BUFFER-FIELD("obj-status":U):BUFFER-VALUE = "New":U.
      END.
      MhLoadQry:GET-NEXT.
    END.

    DELETE OBJECT MhLoadQry.
    DELETE OBJECT MhTTLoad.

    BR-srcfile:REFRESH() IN FRAME {&FRAME-NAME}.
    RUN set_sensitive.


    /*
     Refresh Tabletop as required
    */
    PUBLISH "evRtbGetObjSdoHandle":U (OUTPUT MhTopObjSdo).
    IF VALID-HANDLE(MhTopObjSdo) THEN
      DYNAMIC-FUNCTION('fnRtbSelectWorkspaceModule':U IN MhTopObjSdo,
                       Mwspace-id,Mcurrent-wsmod).

    SESSION:SET-WAIT-STATE("").

    STATUS DEFAULT.

    IF Merror <> "" THEN
      MESSAGE Merror
        VIEW-AS ALERT-BOX ERROR TITLE {&ALERT-TITLE}.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE view_selected_file wWin 
PROCEDURE view_selected_file PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     View the selected file in Progress ADE.
  Parameters:  <none>
  Notes:       Uses rtb_adelib.p ("evRtbAdeEdit" event)
------------------------------------------------------------------------------*/
  DO WITH FRAME {&FRAME-NAME}:

    BR-srcfile:FETCH-SELECTED-ROW(1).

    PUBLISH "evRtbAdeEdit":U
      (INPUT ?,
       INPUT MhSrcBuff:BUFFER-FIELD("object":U):BUFFER-VALUE,
       INPUT MhSrcBuff:BUFFER-FIELD("fullpath":U):BUFFER-VALUE,
       INPUT "ViewUIB":U).

  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnMultipleModsSelected wWin 
FUNCTION fnMultipleModsSelected RETURNS LOGICAL PRIVATE
  (  ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns TRUE if selected files span multiple Workspace Modules
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mfirst-module AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi            AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mmultiple     AS LOGICAL     NO-UNDO INITIAL FALSE.

  $INSPECT-MODULES:
  DO WITH FRAME {&FRAME-NAME}:
 
    DO Mi = 1 TO Br-srcfile:NUM-SELECTED-ROWS WITH FRAME {&FRAME-NAME}:
      
      BR-srcfile:FETCH-SELECTED-ROW(Mi).
      
      IF Mi = 1 THEN
        Mfirst-module = MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE.
      ELSE
        IF Mfirst-module <> MhSrcBuff:BUFFER-FIELD("module":U):BUFFER-VALUE THEN DO:
           Mmultiple = TRUE.
           LEAVE $INSPECT-MODULES.
        END.
    
    END. /* do mi */
  
  END. /* $inspect-modules */

  RETURN Mmultiple.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnRtbCheckValidSubtypePart wWin 
FUNCTION fnRtbCheckValidSubtypePart RETURNS LOGICAL PRIVATE
  ( INPUT Psub-type  AS CHARACTER,
    INPUT Pfile-name AS CHARACTER,
    INPUT Pmodule    AS CHARACTER,
    INPUT Psubdir    AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Determine if filename is valid for selected subtype.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mbasename          AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE McolValues         AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mextension         AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mmodpath           AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-dirs         AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-exts         AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-parts        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpart-suffixes     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mpath              AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Msubname           AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Msuffix            AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mdot               AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mx                 AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mvalid-for-subtype AS LOGICAL     NO-UNDO.

  RUN set_subtype_query (INPUT Psub-type).

  IF Mcurrent-subtype <> "" THEN DO:

    ASSIGN Mextension     = IF R-INDEX(Pfile-name,".") = 0 THEN
                              ""
                            ELSE
                              SUBSTRING(Pfile-name,R-INDEX(Pfile-name,".") + 1)
           McolValues     = DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                             'subtPart-suffixes,subtParts,subtPart-dirs,subtPart-exts':U)
           Mpart-suffixes = ENTRY(2,McolValues,CHR(1))
           Mpart-parts    = ENTRY(3,McolValues,CHR(1))
           Mpart-dirs     = ENTRY(4,McolValues,CHR(1))
           Mpart-exts     = ENTRY(5,McolValues,CHR(1)).
    /*
     Get file specs per main subtype part
    */
    Mdot =  R-INDEX(Pfile-name,".").
            IF Mdot = 0 THEN 
              Mdot = LENGTH(Pfile-name) + 1. /* add one here for the location of '.' if one actually existed.   */

           Msuffix   = IF Mdot > LENGTH(ENTRY(1,Mpart-suffixes)) THEN
                                 SUBSTRING(Pfile-name,
                          Mdot - (LENGTH(ENTRY(1,Mpart-suffixes))),
                                     LENGTH(ENTRY(1,Mpart-suffixes)))
              ELSE "".

           Mbasename = IF Mdot > LENGTH(ENTRY(1,Mpart-suffixes)) THEN
                  SUBSTRING(Pfile-name,1,Mdot - LENGTH(ENTRY(1,Mpart-suffixes)) - 1)
                             ELSE
                               Pfile-name.

    /*
      Determine if object qualifies for subtype
    */
    Mvalid-for-subtype = YES. /* default to yes */
    /*
     Does filename conform to main part specs?
    */
    IF (ENTRY(1,Mpart-exts) <> "" AND Mextension <> ENTRY(1,Mpart-exts))
       OR (ENTRY(1,Mpart-suffixes) <> "" AND NOT Msuffix = ENTRY(1,Mpart-suffixes))
       OR (Psubdir <> ENTRY(1,Mpart-dirs)) THEN
      Mvalid-for-subtype = NO.
    ELSE DO Mx = 2 TO 9:
      IF ENTRY(Mx,Mpart-parts) = "" THEN LEAVE.

      /*
       Does subtype part exist?
      */
      IF DYNAMIC-FUNCTION('fnRtbFetchModuleRecord':U IN h_rtb_q_mod,PModule) THEN
        ASSIGN Mmodpath = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_moddef,
                                                'directory':U),CHR(1)).

      ASSIGN Mpath = Mworking-dir
                     + "/"
                     + (IF Mmodpath <> "" THEN
                          (Mmodpath + "/")
                        ELSE
                          "")
                     + (IF ENTRY(Mx,Mpart-dirs) <> "" THEN
                          (ENTRY(Mx,Mpart-dirs) + "/")
                        ELSE
                          "").
                   
      Msubname = Mpath
                 + Mbasename
                 + ENTRY(Mx,Mpart-suffixes)
                 + (IF ENTRY(Mx,Mpart-exts) <> "" THEN
                     ("." + ENTRY(Mx,Mpart-exts))
                    ELSE
                      "").

      IF SEARCH(Msubname) = ? THEN DO:
        Mvalid-for-subtype = NO.
        LEAVE.
      END.

      /*
       Filename not valid if it conforms to a subpart spec
      */
      IF Mextension <> ENTRY(Mx,Mpart-exts)
         OR Psubdir <> ENTRY(Mx,Mpart-dirs) THEN NEXT.

      IF ENTRY(Mx,Mpart-suffixes) <> "" THEN
      ASSIGN Mdot    = IF ENTRY(Mx,Mpart-exts) = "" THEN
                         LENGTH(Pfile-name)
                       ELSE
                         R-INDEX(Pfile-name,".")
             Msuffix = IF Mdot > LENGTH(ENTRY(Mx,Mpart-suffixes)) THEN
                         SUBSTRING(Pfile-name,
                                   Mdot - LENGTH(ENTRY(Mx,Mpart-suffixes)),
                                   LENGTH(ENTRY(Mx,Mpart-suffixes)))
                       ELSE
                         "".

      IF Msuffix = ENTRY(Mx,Mpart-suffixes) THEN DO:
        Mvalid-for-subtype = NO.
        LEAVE.
      END.
    END. /* do mx = 2 to 9 */
  END.

  RETURN Mvalid-for-subtype.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnRtbGetAllSubtypePaths wWin 
FUNCTION fnRtbGetAllSubtypePaths RETURNS CHARACTER PRIVATE
  (  ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns a list of unique subdirectories for all defined subtypes.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mpaths         AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Msubt-paths    AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Msubtype       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi             AS INTEGER     NO-UNDO.

  RUN fetchFirst IN h_rtb_u_subt.

  DO WHILE DYNAMIC-FUNCTION('rowAvailable':U IN h_rtb_u_subt,'NEXT':U):
    Mpaths = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                      'subtPart-dirs':U),CHR(1)).
    DO Mi = 1 TO NUM-ENTRIES(Mpaths):
      IF LOOKUP(ENTRY(Mi,Mpaths),Msubt-paths) = 0 THEN
        Msubt-paths = Msubt-paths + (IF Msubt-paths = "" THEN "" ELSE ",")
                      + ENTRY(Mi,Mpaths).
    END.
    Msubtype = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                    'sub-type':U),CHR(1)).
    RUN fetchNext IN h_rtb_u_subt.
  END.
  
  IF Mcurrent-subtype <> "" AND (Msubtype <> Mcurrent-subtype) THEN
     RUN set_subtype_query (INPUT Mcurrent-subtype).

  RETURN Msubt-paths.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnRtbGetSubtypePaths wWin 
FUNCTION fnRtbGetSubtypePaths RETURNS CHARACTER PRIVATE
  ( INPUT Psub-type AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Msubt-paths AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi          AS INTEGER     NO-UNDO.

  IF Mcurrent-subtype <> Psub-type THEN
    RUN set_subtype_query (Psub-type).

  Msubt-paths = ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                         'subtPart-dirs':U),CHR(1)).
                                      
  RETURN Msubt-paths.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnRtbSubtypePartsCount wWin 
FUNCTION fnRtbSubtypePartsCount RETURNS INTEGER PRIVATE
  ( INPUT Psub-type AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Return the number of parts defined for specified subtype.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mcount AS INTEGER    NO-UNDO.

  RUN set_subtype_query (INPUT Psub-type).

  IF Mcurrent-subtype <> "" THEN
    count-loop:
    DO Mcount = 1 TO 9:
      IF ENTRY(Mcount,ENTRY(2,DYNAMIC-FUNCTION('colValues':U IN h_rtb_u_subt,
                                               'subtParts':U),CHR(1))) = "" THEN DO:
        Mcount = Mcount - 1.
        LEAVE count-loop.
      END.
    END. /* count-loop */

  RETURN Mcount.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

