&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          rtb              PROGRESS
*/
&Scoped-define WINDOW-NAME wiWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" wiWin _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" wiWin _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wiWin 
/*---------------------------------------------------------------------------------
  File: ryschsynchw.w

  Description:  RTB Dynamics Schema Synch Window

  Purpose:

  Parameters:   <none>

  History:
  --------
  (v:010000)    Task:    11000756   UserRef:    
                Date:   01/22/2007  Author:     Thomas Hansen

  Update Notes: Created from Template rysttbconw.w

---------------------------------------------------------------------------------*/
/*                   This .W file was created with the Progress UIB.             */
/*-------------------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

&scop object-name       ryrtbschsynchw.w
DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&scop object-version    010000

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* object identifying preprocessor */
&glob   astra2-staticSmartWindow yes

{src/adm2/globals.i}
{checkerr.i &define-only = YES}
{launch.i &Define-only = YES}

DEFINE VARIABLE gcRtbCurrentWorkspace   AS CHARACTER   NO-UNDO.
DEFINE VARIABLE giRtbCurrentTaskNum     AS INTEGER     NO-UNDO.
DEFINE VARIABLE giProcessTaskNum        AS INTEGER     NO-UNDO.

DEFINE TEMP-TABLE ttSchemaObject    NO-UNDO
       FIELD cWorkspace       AS CHARACTER
       FIELD cProductModule   AS CHARACTER
       FIELD cObjectName      AS CHARACTER
       FIELD cObjType         AS CHARACTER 
       FIELD cTable           AS CHARACTER 
       FIELD cDatabase        AS CHARACTER 
       INDEX idxMain          IS PRIMARY UNIQUE
             cObjectName
       INDEX idxFull          IS UNIQUE
              cWorkspace
              cProductModule
              cObjectName.

/* DEFINE TEMP-TABLE ttError     NO-UNDO      */
/*        FIELD cObjectName      AS CHARACTER */
/*        FIELD cError           AS CHARACTER */
/*        INDEX idxMain          IS PRIMARY   */
/*               cObjectName                  */
/*               cError.                      */
/*                                            */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target,Filter-target,Filter-Source

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME frMain
&Scoped-define BROWSE-NAME BrBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES rtb_ver

/* Definitions for BROWSE BrBrowse                                      */
&Scoped-define FIELDS-IN-QUERY-BrBrowse rtb_ver.object rtb_ver.obj-type ~
rtb_ver.pmod rtb_ver.version rtb_ver.description 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BrBrowse 
&Scoped-define QUERY-STRING-BrBrowse FOR EACH rtb_ver ~
      WHERE rtb_ver.task-num = giProcessTaskNum ~
 AND (rtb.rtb_ver.obj-type = "PFIELD" OR rtb_ver.obj-type = "PFILE") NO-LOCK ~
    BY rtb_ver.object INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-BrBrowse OPEN QUERY BrBrowse FOR EACH rtb_ver ~
      WHERE rtb_ver.task-num = giProcessTaskNum ~
 AND (rtb.rtb_ver.obj-type = "PFIELD" OR rtb_ver.obj-type = "PFILE") NO-LOCK ~
    BY rtb_ver.object INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BrBrowse rtb_ver
&Scoped-define FIRST-TABLE-IN-QUERY-BrBrowse rtb_ver


/* Definitions for FRAME frMain                                         */
&Scoped-define OPEN-BROWSERS-IN-QUERY-frMain ~
    ~{&OPEN-QUERY-BrBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS buRefresh coTask BrBrowse buAllSelect ~
buAllDeselect fiPrefixLength raAuditing fiSeparator ToAuto ~
toOverrideWithSchema coEntityProductModule coDFProductModule toAssociateDF ~
buOK buCancel 
&Scoped-Define DISPLAYED-OBJECTS coWorkspace coTask fiPrefixLength ~
raAuditing fiSeparator ToAuto toOverrideWithSchema coEntityProductModule ~
coDFProductModule toAssociateDF 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getFieldTable wiWin 
FUNCTION getFieldTable RETURNS CHARACTER
  (INPUT prObjectRowid   AS ROWID)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getObjectDatabase wiWin 
FUNCTION getObjectDatabase RETURNS CHARACTER
  (INPUT prObjectRowid   AS ROWID)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR wiWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON buAllDeselect DEFAULT 
     LABEL "&Deselect All" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON buAllSelect DEFAULT 
     LABEL "Select &All" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON buCancel AUTO-END-KEY DEFAULT 
     LABEL "&Exit" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON buOK DEFAULT 
     LABEL "&Process Selected Objects" 
     SIZE 31.4 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON buRefresh 
     LABEL "Refres&h" 
     SIZE 15 BY 1.14 TOOLTIP "Refresh list of objects"
     BGCOLOR 8 .

DEFINE VARIABLE coDFProductModule AS CHARACTER FORMAT "X(256)":U 
     LABEL "DataField product module" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 8
     DROP-DOWN-LIST
     SIZE 60 BY 1
     BGCOLOR 15  NO-UNDO.

DEFINE VARIABLE coEntityProductModule AS CHARACTER FORMAT "X(256)":U 
     LABEL "Entity product module" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 8
     DROP-DOWN-LIST
     SIZE 60 BY 1
     BGCOLOR 15  NO-UNDO.

DEFINE VARIABLE coTask AS INTEGER FORMAT "999999999":U INITIAL 0 
     LABEL "Task" 
     CONTEXT-HELP-ID 0
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEM-PAIRS "Item 1",0
     DROP-DOWN-LIST
     SIZE 60 BY 1 NO-UNDO.

DEFINE VARIABLE coWorkspace AS CHARACTER FORMAT "X(256)":U 
     LABEL "Workspace" 
     VIEW-AS COMBO-BOX SORT INNER-LINES 8
     DROP-DOWN-LIST
     SIZE 60 BY 1
     BGCOLOR 15  NO-UNDO.

DEFINE VARIABLE fiPrefixLength AS INTEGER FORMAT ">9":U INITIAL 4 
     LABEL "Prefix length" 
     VIEW-AS FILL-IN 
     SIZE 4 BY 1 TOOLTIP "Table prefix length or 0 for none, default is 4" NO-UNDO.

DEFINE VARIABLE fiSeparator AS CHARACTER FORMAT "X(5)":U INITIAL "_" 
     LABEL "Field name separator" 
     VIEW-AS FILL-IN 
     SIZE 18.8 BY 1 TOOLTIP "Word separation character for field names, default is underscore" NO-UNDO.

DEFINE VARIABLE raAuditing AS CHARACTER INITIAL "I" 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Yes", "Y",
"No", "N",
"Ignore", "I"
     SIZE 12 BY 2.29 TOOLTIP "Enable auditing for selected entities" NO-UNDO.

DEFINE VARIABLE toAssociateDF AS LOGICAL INITIAL yes 
     LABEL "Associate DataFields with entities" 
     VIEW-AS TOGGLE-BOX
     SIZE 40.4 BY .81 NO-UNDO.

DEFINE VARIABLE ToAuto AS LOGICAL INITIAL yes 
     LABEL "Auto properform strings" 
     VIEW-AS TOGGLE-BOX
     SIZE 27.2 BY .81 TOOLTIP "Enable properforming of character strings for selected entities" NO-UNDO.

DEFINE VARIABLE toOverrideWithSchema AS LOGICAL INITIAL yes 
     LABEL "Overwrite all attributes from schema" 
     VIEW-AS TOGGLE-BOX
     SIZE 42.8 BY .81 TOOLTIP "Overwrite all local attributes such as Format, Label and Help with schema values" NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BrBrowse FOR 
      rtb_ver SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BrBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BrBrowse wiWin _STRUCTURED
  QUERY BrBrowse NO-LOCK DISPLAY
      rtb_ver.object FORMAT "x(50)":U
      rtb_ver.obj-type FORMAT "x(6)":U WIDTH 8
      rtb_ver.pmod FORMAT "x(20)":U
      rtb_ver.version FORMAT "999999":U WIDTH 10
      rtb_ver.description FORMAT "x(40)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH SEPARATORS MULTIPLE SIZE 97.8 BY 10 ROW-HEIGHT-CHARS .61.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME frMain
     coWorkspace AT ROW 1.24 COL 7.8
     buRefresh AT ROW 2.14 COL 85
     coTask AT ROW 2.29 COL 18 COLON-ALIGNED
     BrBrowse AT ROW 3.43 COL 2.2
     buAllSelect AT ROW 13.52 COL 2.6
     buAllDeselect AT ROW 13.52 COL 18.4
     fiPrefixLength AT ROW 14.91 COL 28 COLON-ALIGNED
     raAuditing AT ROW 14.91 COL 81.8 NO-LABEL
     fiSeparator AT ROW 15.91 COL 28 COLON-ALIGNED
     ToAuto AT ROW 16.91 COL 30
     toOverrideWithSchema AT ROW 17.91 COL 30
     coEntityProductModule AT ROW 18.91 COL 8.4
     coDFProductModule AT ROW 19.91 COL 4.6
     toAssociateDF AT ROW 20.95 COL 30
     buOK AT ROW 22.48 COL 2.8
     buCancel AT ROW 22.48 COL 85.6
     "Auditing enabled:" VIEW-AS TEXT
          SIZE 17.6 BY .76 AT ROW 14.91 COL 63
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 100 BY 23.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target,Filter-target,Filter-Source
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW wiWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Roundtable Dynamics Entity Synchronization"
         HEIGHT             = 23
         WIDTH              = 100
         MAX-HEIGHT         = 44.43
         MAX-WIDTH          = 256
         VIRTUAL-HEIGHT     = 44.43
         VIRTUAL-WIDTH      = 256
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = yes
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wiWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW wiWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME frMain
   FRAME-NAME                                                           */
/* BROWSE-TAB BrBrowse coTask frMain */
ASSIGN 
       BrBrowse:COLUMN-RESIZABLE IN FRAME frMain       = TRUE.

/* SETTINGS FOR COMBO-BOX coDFProductModule IN FRAME frMain
   ALIGN-L                                                              */
/* SETTINGS FOR COMBO-BOX coEntityProductModule IN FRAME frMain
   ALIGN-L                                                              */
/* SETTINGS FOR COMBO-BOX coWorkspace IN FRAME frMain
   NO-ENABLE ALIGN-L                                                    */
ASSIGN 
       fiPrefixLength:PRIVATE-DATA IN FRAME frMain     = 
                "4".

ASSIGN 
       fiSeparator:PRIVATE-DATA IN FRAME frMain     = 
                "_".

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wiWin)
THEN wiWin:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BrBrowse
/* Query rebuild information for BROWSE BrBrowse
     _TblList          = "rtb.rtb_ver"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _OrdList          = "rtb.rtb_ver.object|yes"
     _Where[1]         = "rtb.rtb_ver.task-num = giProcessTaskNum
 AND (rtb.rtb_ver.obj-type = ""PFIELD"" OR rtb.rtb_ver.obj-type = ""PFILE"")"
     _FldNameList[1]   > rtb.rtb_ver.object
"rtb_ver.object" ? "x(50)" "character" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > rtb.rtb_ver.obj-type
"rtb_ver.obj-type" ? ? "character" ? ? ? ? ? ? no ? no no "8" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > rtb.rtb_ver.pmod
"rtb_ver.pmod" ? "x(20)" "character" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[4]   > rtb.rtb_ver.version
"rtb_ver.version" ? ? "integer" ? ? ? ? ? ? no ? no no "10" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[5]   = rtb.rtb_ver.description
     _Query            is OPENED
*/  /* BROWSE BrBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME wiWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wiWin wiWin
ON END-ERROR OF wiWin /* Roundtable Dynamics Entity Synchronization */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wiWin wiWin
ON WINDOW-CLOSE OF wiWin /* Roundtable Dynamics Entity Synchronization */
DO:
  /* This ADM code must be left here in order for the SmartWindow
     and its descendents to terminate properly on exit. */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME buAllDeselect
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL buAllDeselect wiWin
ON CHOOSE OF buAllDeselect IN FRAME frMain /* Deselect All */
DO:
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE lBrwReturn  AS LOGICAL      NO-UNDO.

   DO WITH FRAME {&FRAME-NAME}:
     lBrwReturn = {&BROWSE-NAME}:DESELECT-ROWS().
   END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME buAllSelect
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL buAllSelect wiWin
ON CHOOSE OF buAllSelect IN FRAME frMain /* Select All */
DO:
   DEFINE VARIABLE lBrwReturn  AS LOGICAL      NO-UNDO.

  DO WITH FRAME {&FRAME-NAME}:
    lBrwReturn = {&BROWSE-NAME}:SELECT-ALL().
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME buCancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL buCancel wiWin
ON CHOOSE OF buCancel IN FRAME frMain /* Exit */
DO:

    /* This event will close the window and terminate the procedure.  */
    APPLY "CLOSE":U TO THIS-PROCEDURE.
    RETURN NO-APPLY.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME buOK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL buOK wiWin
ON CHOOSE OF buOK IN FRAME frMain /* Process Selected Objects */
DO:
    DEFINE VARIABLE lChoice             AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE cMessage            AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE iRtbCurrentTaskNum AS INTEGER     NO-UNDO.
    
  DO WITH FRAME {&FRAME-NAME}:

   IF {&BROWSE-NAME}:NUM-SELECTED-ROWS = 0 THEN 
   DO:
      MESSAGE "No objects were selected to process":U.
      RETURN NO-APPLY.
   END.

   ASSIGN
     cMessage = "Do you wish to proceed with performing a Dynamics Entity Import on the selected schema objects?"
              + CHR(10)  + CHR(10).
   
   MESSAGE cMessage
      VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO
      UPDATE lChoice.
      
  IF lChoice = YES THEN
    RUN ProcessObjects.
  END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME buRefresh
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL buRefresh wiWin
ON CHOOSE OF buRefresh IN FRAME frMain /* Refresh */
DO:  
   {&OPEN-QUERY-{&BROWSE-NAME}}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME coDFProductModule
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL coDFProductModule wiWin
ON VALUE-CHANGED OF coDFProductModule IN FRAME frMain /* DataField product module */
DO:
    ASSIGN coDFProductModule.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME coEntityProductModule
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL coEntityProductModule wiWin
ON VALUE-CHANGED OF coEntityProductModule IN FRAME frMain /* Entity product module */
DO:
    ASSIGN coEntityProductModule.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME coTask
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL coTask wiWin
ON VALUE-CHANGED OF coTask IN FRAME frMain /* Task */
DO:
  ASSIGN 
     coTask
     giProcessTaskNum = coTask.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME coWorkspace
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL coWorkspace wiWin
ON VALUE-CHANGED OF coWorkspace IN FRAME frMain /* Workspace */
DO:

    ASSIGN coWorkSpace.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BrBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wiWin 


/* ***************************  Main Block  *************************** */

/* Include custom  Main Block code for SmartWindows. */
{src/adm2/windowmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wiWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildCoTask wiWin 
PROCEDURE buildCoTask :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
   DEFINE VARIABLE cTaskItem  AS CHARACTER   NO-UNDO.
   
   DO WITH FRAME {&FRAME-NAME}:
      coTask:SCREEN-VALUE = "0".
      coTask:DELETE(1).
      
      FOR EACH rtb_task  NO-LOCK WHERE 
          rtb_task.wspace-id = gcRtbCUrrentWorkspace AND 
          rtb_task.task-status = "W":U: 
         ASSIGN cTaskItem = STRING(rtb_task.task-num) + " - " + rtb_task.summary.
         coTask:ADD-LAST(cTaskItem, rtb_task.task-num) NO-ERROR.
      END.

      IF giRtbCurrentTaskNum NE 0  THEN
      DO:
         ASSIGN coTask:SCREEN-VALUE = STRING(giRtbCurrentTaskNum).    
         APPLY "VALUE-CHANGED" TO coTask.
         DISABLE coTask.
      END.         
   END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildCoWorkspace wiWin 
PROCEDURE buildCoWorkspace :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
            coWorkSpace          = grtb-wspace-id
------------------------------------------------------------------------------*/
  DEFINE VARIABLE cRtbCurrentWorkspace AS CHARACTER   NO-UNDO.
  
  /* Get the current workspace  */
  PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT cRtbCurrentWorkspace).
  
  DO WITH FRAME {&FRAME-NAME}:

    ASSIGN coWorkspace:LIST-ITEMS = "":U.

    FIND FIRST rtb_wspace NO-LOCK WHERE 
       rtb_wspace.wspace-id = cRtbCurrentWorkspace NO-ERROR.
    IF AVAILABLE rtb_wspace THEN 
      coWorkspace:ADD-FIRST(LC(rtb_wspace.wspace-id)).
    ELSE 
      coWorkspace:ADD-FIRST("NONE":U).

    IF  coWorkspace:LIST-ITEMS <> "":U AND 
        coWorkspace:LIST-ITEMS <> ? THEN
      ASSIGN coWorkspace:SCREEN-VALUE = ENTRY(1,coWorkspace:LIST-ITEMS).
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildObjectTT wiWin 
PROCEDURE buildObjectTT :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT-OUTPUT PARAMETER TABLE FOR ttSchemaObject.

  DEFINE VARIABLE iLoopRows   AS INTEGER      NO-UNDO.
  DEFINE VARIABLE iLoopCols   AS INTEGER      NO-UNDO.
  DEFINE VARIABLE lBrwReturn  AS LOGICAL      NO-UNDO.

  DEFINE BUFFER b_rtb_object FOR rtb_object.
                                          
  DO WITH FRAME {&FRAME-NAME}:    
    DO iLoopRows = 1 TO {&BROWSE-NAME}:NUM-SELECTED-ROWS:

      lBrwReturn = {&BROWSE-NAME}:FETCH-SELECTED-ROW(iLoopRows).

      GET CURRENT {&BROWSE-NAME} NO-LOCK.
      FIND FIRST ttSchemaObject EXCLUSIVE-LOCK WHERE 
         ttSchemaObject.cWorkspace     = coWorkspace AND   
         ttSchemaObject.cProductModule = rtb_ver.pmod AND   
         ttSchemaObject.cObjectName    = rtb_ver.object AND 
         ttSchemaObject.cObjType       = rtb_ver.obj-type NO-ERROR.

      IF NOT AVAILABLE ttSchemaObject THEN
        CREATE ttSchemaObject.

      ASSIGN
        ttSchemaObject.cWorkspace     = coWorkspace
        ttSchemaObject.cProductModule = rtb_ver.pmod
        ttSchemaObject.cObjectName    = rtb_ver.object
        ttSchemaObject.cObjType       = rtb_ver.obj-type. 

      FIND FIRST b_rtb_object OF rtb_ver WHERE b_rtb_object.wspace-id = gcRtbCurrentWorkspace NO-LOCK.  
      ASSIGN ttSchemaObject.cDatabase      = DYNAMIC-FUNCTION('getObjectDatabase':U, INPUT ROWID(b_rtb_object)).
      IF RETURN-VALUE NE "":U THEN
         PUBLISH "evRtbSetStatusMessage":U (INPUT CHR(10) + RETURN-VALUE).

      ASSIGN ttSchemaObject.cTable      = DYNAMIC-FUNCTION('getFieldTable':U, INPUT ROWID(b_rtb_object)).
    END.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildproductModuleCos wiWin 
PROCEDURE buildproductModuleCos :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
            coWorkSpace          = grtb-wspace-id
------------------------------------------------------------------------------*/
  DO WITH FRAME {&FRAME-NAME}:
   ASSIGN 
      coEntityProductModule:LIST-ITEMS = "":U
      coDFProductModule:LIST-ITEMS     = "":U.

   FOR EACH gsc_product_module NO-LOCK
   BY gsc_product_module.product_module_code:
      coEntityProductModule:ADD-LAST(LC(gsc_product_module.product_module_code)).
      coDFProductModule:ADD-LAST(LC(gsc_product_module.product_module_code)).
      
   END.

   ASSIGN
      coEntityProductModule:SCREEN-VALUE = ENTRY(1,coEntityProductModule:LIST-ITEMS)
      coDFProductModule:SCREEN-VALUE = ENTRY(1,coDFProductModule:LIST-ITEMS).
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wiWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wiWin)
  THEN DELETE WIDGET wiWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wiWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY coWorkspace coTask fiPrefixLength raAuditing fiSeparator ToAuto 
          toOverrideWithSchema coEntityProductModule coDFProductModule 
          toAssociateDF 
      WITH FRAME frMain IN WINDOW wiWin.
  ENABLE buRefresh coTask BrBrowse buAllSelect buAllDeselect fiPrefixLength 
         raAuditing fiSeparator ToAuto toOverrideWithSchema 
         coEntityProductModule coDFProductModule toAssociateDF buOK buCancel 
      WITH FRAME frMain IN WINDOW wiWin.
  {&OPEN-BROWSERS-IN-QUERY-frMain}
  VIEW wiWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE exitObject wiWin 
PROCEDURE exitObject :
/*------------------------------------------------------------------------------
  Purpose:  Window-specific override of this procedure which destroys 
            its contents and itself.
    Notes:  
------------------------------------------------------------------------------*/

  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject wiWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */

  /* Get the current workspace  */
  PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

  /* Get the current workspace  */
  PUBLISH "evRtbGetCurrentTask":U (OUTPUT giRtbCurrentTaskNum).

  RUN buildCoWorkspace.
  RUN buildproductModuleCos.
  RUN buildCoTask.

  IF gcRtbCurrentWorkspace = "":U THEN
     ENABLE coWorkspace.

  APPLY "CHOOSE" TO buRefresh IN FRAME {&FRAME-NAME}.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectEntityImport wiWin 
PROCEDURE objectEntityImport :
/*------------------------------------------------------------------------------
  Purpose:     To check-out objects specified.
  Parameters:  <none>
  Notes:       Done so that .ado files that have been regenerated get
               re-registered in the SCM tool.
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER TABLE               FOR ttSchemaObject.
  DEFINE INPUT  PARAMETER piTask              AS INTEGER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcEntityModule      AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER pcDataFieldModule   AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pcError             AS CHARACTER NO-UNDO.

  DEFINE VARIABLE cError                      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cFullMessage                AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cIgnore                     AS CHARACTER NO-UNDO.
  DEFINE VARIABLE lIgnore                     AS LOGICAL   NO-UNDO.
  DEFINE VARIABLE cDynObjectType              AS CHARACTER NO-UNDO.
  DEFINE VARIABLE iMaxObjects                 AS INTEGER   NO-UNDO.
  DEFINE VARIABLE iCurrentObjectNumber        AS INTEGER   NO-UNDO.
  DEFINE VARIABLE hRDM                        AS HANDLE    NO-UNDO.

   IF NOT VALID-HANDLE(hRDM) THEN
      ASSIGN hRdm = DYNAMIC-FUNCTION("getManagerHandle":U IN THIS-PROCEDURE, INPUT "RepositoryDesignManager":U).   

   ASSIGN 
      iMaxObjects          = 0
      iCurrentObjectNumber = 0. 
  
   PUBLISH "evRtbSetStatusMessage":U (INPUT "Processing RTB Dynamics Schema Entity Import...").
      
   PROCESS EVENTS.    
   /* Count the number of objects to process to show on the status bar*/
   FOR EACH ttSchemaObject NO-LOCK: 
      ASSIGN iMaxObjects = iMaxObjects + 1. 
   END.
   
   IF iMaxObjects > 0 THEN
      PUBLISH "evRTBSetStatusWinMax" (INPUT iMaxObjects).       
  
   
   DO WITH FRAME {&FRAME-NAME}:
      object-loop:
      FOR EACH ttSchemaObject BY ttSchemaObject.cObjType:
         /* Set the current object number and publish this to the status window */
         ASSIGN 
            iCurrentObjectNumber = iCurrentObjectNumber + 1
            cError = "":U. 

         PUBLISH "evRTBSetStatusWinValue" (INPUT iCurrentObjectNumber).       
         DO:
            IF ttSchemaObject.cObjType = "PFIELD" THEN
            DO:
               ASSIGN cDynObjectType = "DataField":U.

               PUBLISH "evRtbSetStatusMessage":U (INPUT "Generating DataField for : " + ttSchemaObject.cObjectName).
               IF VALID-HANDLE(hRDM) THEN
               DO:
                  RUN generateDataFields IN hRDM ( INPUT ttSchemaObject.cDatabase,             /* pcDataBaseName */
                                                   INPUT ttSchemaObject.cTable,    /* pcTableName */
                                                   INPUT pcDataFieldModule,  /* pcProductModuleCode */
                                                   INPUT "":U,                            /* pcResultCode */
                                                   INPUT NO,                              /* plGenerateFromDataObject */
                                                   INPUT "":U,                            /* pcDataObjectFieldList */
                                                   INPUT "":U,                            /* pcSdoObjectName */
                                                   INPUT cDynObjectType,       /* pcObjectTypeCode  */
                                                   INPUT "*",
                                                   INPUT ttSchemaObject.cObjectName /* pcFieldNames */  )NO-ERROR.
                  IF ERROR-STATUS:ERROR OR RETURN-VALUE NE "":U THEN
                      ASSIGN cError = RETURN-VALUE.               
               END.
               ELSE 
                  PUBLISH "evRtbSetStatusMessage":U (INPUT "Repository Design Manager handle not valid.").
            END.
            ELSE 
            IF ttSchemaObject.cObjType = "PFILE":U THEN 
            DO:
               ASSIGN cDynObjectType = "Entity":U. 
               PUBLISH "evRtbSetStatusMessage":U (INPUT "Generating Entity for : " + ttSchemaObject.cObjectName).
               RUN generateEntityObject IN hRDM ( INPUT (ttSchemaObject.cDatabase + CHR(3) + ttSchemaObject.cTable),
                                                  INPUT cDynObjectType,
                                                  INPUT pcEntityModule,
                                                  INPUT toAuto:SCREEN-VALUE,
                                                  INPUT fiPrefixLength:SCREEN-VALUE,
                                                  INPUT fiSeparator:SCREEN-VALUE,
                                                  INPUT raAuditing:SCREEN-VALUE,
                                                  INPUT "":U,      /* pcDescFieldQualifiers */
                                                  INPUT "":U,      /* pcKeyFieldQualifiers  */
                                                  INPUT "":U,      /* pcObjFieldQualifiers  */
                                                  INPUT NO,        /* version_data */
                                                  INPUT NO,        /* deploy_data */
                                                  INPUT NO,        /* reuse_deleted_keys */
                                                  INPUT toAssociateDF:CHECKED         /* plAssociateDataFields   */  ) NO-ERROR.
               IF ERROR-STATUS:ERROR OR RETURN-VALUE NE "":U THEN
                   ASSIGN cError = RETURN-VALUE.
            END.

            IF cError NE "":U THEN 
            DO:
               RUN afmessagep IN gshSessionManager
                                      (INPUT  cError,
                                       INPUT  "":U,
                                       INPUT  "":U,
                                       OUTPUT cError,
                                       OUTPUT cFullMessage,
                                       OUTPUT cIgnore,
                                       OUTPUT cIgnore,
                                       OUTPUT lIgnore,
                                       OUTPUT lIgnore) 
                                       NO-ERROR.

               PUBLISH "evRtbSetStatusMessage":U (INPUT "Error : " + cError). 
               NEXT object-loop.
            END.
            ELSE 
               PUBLISH "evRtbSetStatusMessage":U (INPUT "   Processed object : " + ttSchemaObject.cObjectName).
         END.
       PROCESS EVENTS.
     END.  /* object-loop */   
   END.

  ERROR-STATUS:ERROR = NO.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE processObjects wiWin 
PROCEDURE processObjects :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
   DEFINE VARIABLE cFieldList AS CHARACTER   NO-UNDO.

   DEFINE VARIABLE iErrorLoop                    AS INTEGER    NO-UNDO.
   DEFINE VARIABLE cErrorLine                    AS CHARACTER  NO-UNDO.
   DEFINE VARIABLE cError                        AS CHARACTER  NO-UNDO.
   DEFINE VARIABLE cButton                       AS CHARACTER  NO-UNDO.
   
   DEFINE VARIABLE ghRyXmlPlip                   AS HANDLE       NO-UNDO.
   DEFINE VARIABLE hStatusWindow                 AS HANDLE      NO-UNDO.
   DEFINE VARIABLE iRtbCurrentTaskNum            AS INTEGER     NO-UNDO.
      
   /* If connected to RTB display status window */    
   IF CONNECTED("rtb":U) THEN 
   DO:
      hStatusWindow = DYNAMIC-FUNCTION('fnRtbRunWindowOnce':U,"rtb/w/rtb_statuswin.w":U).
      PUBLISH "evRTBSetStatusWinTitle":U (INPUT "Roundtable Dynamics Schema Synch"). 
      PUBLISH "evRTBSetStatusWinCancellable":U. 
   END.

   EMPTY TEMP-TABLE ttSchemaObject.

   IF giProcessTaskNum = 0 THEN
   DO:
      MESSAGE 
         "You have not selected a task to use for processing. Processing cancelled!"
         VIEW-AS ALERT-BOX INFO BUTTONS OK.
      RETURN.
   END.

   RUN buildObjectTT (INPUT-OUTPUT TABLE ttSchemaObject).
   RUN objectEntityImport (INPUT TABLE ttSchemaObject, 
                           INPUT giProcessTaskNum, 
                           INPUT coEntityProductModule, 
                           INPUT coDFProductModule, 
                           OUTPUT cError ).

   PUBLISH "evRtbSetStatusMessage":U (INPUT CHR(10) + "Object processing completed...").
   PUBLISH "evRTBDisableStatusWinCancel":U. 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getFieldTable wiWin 
FUNCTION getFieldTable RETURNS CHARACTER
  (INPUT prObjectRowid   AS ROWID) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/   
   DEFINE VARIABLE cTable  AS CHARACTER   NO-UNDO.
   DEFINE VARIABLE cError  AS CHARACTER   NO-UNDO.
   
   DEFINE BUFFER Brtb_object FOR rtb_object.
   DEFINE BUFFER Brtb_xref   FOR rtb_xref.  

   FIND rtb_object WHERE ROWID(rtb_object) = prObjectRowid NO-LOCK. 
   
   FIND FIRST rtb_wspace WHERE rtb_wspace.wspace-id = rtb_object.wspace-id NO-LOCK.
   
   IF rtb_object.obj-type = "PFIELD":U THEN
   DO:
      /* Find the PFILE referencing the PFIELD object */
      FIND FIRST rtb_xref WHERE
         rtb_xref.wspace-guid       = rtb_wspace.wspace-guid AND
         rtb_xref.ref-object-guid-1 = rtb_object.object-guid AND
         rtb_xref.ref-type          = 11 /* FILE */ NO-LOCK NO-ERROR.

      IF NOT AVAILABLE rtb_xref THEN
      DO:
         ASSIGN cError = "Could not find PFILE Xref for " + rtb_object.object.  
         RETURN cError. 
      END.
      ELSE 
      /* Find the PDBASE referencing the PFILE object */
      /* Find the PDBASE and show it. */
      IF AVAILABLE rtb_xref THEN
      DO:
         FIND Brtb_object WHERE Brtb_object.object-guid = rtb_xref.src-object-guid.
         ASSIGN cTable = Brtb_object.object.  
      END.
   END.
   ELSE 
   IF rtb_object.obj-type = "PFILE":U THEN
   DO:
      ASSIGN cTable = rtb_object.object. 
   END.
   
   RETURN cTable.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getObjectDatabase wiWin 
FUNCTION getObjectDatabase RETURNS CHARACTER
  (INPUT prObjectRowid   AS ROWID) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
   DEFINE VARIABLE cDatabase  AS CHARACTER   NO-UNDO.
   DEFINE VARIABLE cError     AS CHARACTER   NO-UNDO.
   
   
   DEFINE BUFFER Brtb_object FOR rtb_object.
   DEFINE BUFFER Brtb_xref   FOR rtb_xref.  
   
   FIND rtb_object WHERE 
      ROWID(rtb_object) = prObjectRowid NO-LOCK. 
   
   FIND FIRST rtb_wspace WHERE rtb_wspace.wspace-id = rtb_object.wspace-id NO-LOCK.
   
   IF rtb_object.obj-type = "PFIELD":U THEN
   DO:
      FIND FIRST rtb_xref WHERE
         rtb_xref.wspace-guid       = rtb_wspace.wspace-guid AND
         rtb_xref.ref-object-guid-1 = rtb_object.object-guid AND
         rtb_xref.ref-type          = 11 /* FILE */ NO-LOCK NO-ERROR.
      IF NOT AVAILABLE rtb_xref THEN
      DO:
         ASSIGN cError = "Could not find PFILE Xref for " + rtb_object.object.  
         RETURN cError. 
      END.

      /* Find the PDBASE referencing the PFILE object */
         FIND FIRST Brtb_xref WHERE
            Brtb_xref.wspace-guid = rtb_wspace.wspace-guid AND
            Brtb_xref.ref-object-guid-1    = rtb_xref.src-object-guid AND
            Brtb_xref.src-type     = 2 /* DBASE */ NO-LOCK  NO-ERROR.
         IF NOT AVAILABLE Brtb_xref THEN
         DO:
            ASSIGN cError = "Could not find PDBASE Xref for " + rtb_object.object.  
            RETURN cError. 
         END.
   END.
   ELSE
   IF rtb_object.obj-type = "PFILE":U THEN
   DO:
      /* Find the PDBASE refereicing the PFILE object */
      FIND FIRST Brtb_xref     
         WHERE Brtb_xref.wspace-guid = rtb_wspace.wspace-guid AND  
         Brtb_xref.ref-object-guid-1 = rtb_object.object-guid AND 
         Brtb_xref.src-type          = 2 /* DBASE */ NO-LOCK  NO-ERROR.   
      IF NOT AVAILABLE Brtb_xref THEN
      DO:
         ASSIGN cError = "Could not find PDBASE Xref for " + rtb_object.object.  
         RETURN cError. 
      END.
   END.

   /* Find the PDBASE and show it. */
   IF AVAILABLE Brtb_xref THEN
   DO:
      FIND Brtb_object WHERE Brtb_object.object-guid = Brtb_xref.src-object-guid.
      ASSIGN cDatabase = Brtb_object.object.  
   END.

   RETURN cDatabase.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

